<?php

// Exit if accessed directly.
if ( ! defined( 'ABSPATH' ) ) {
	exit;
}

function register_full_grid_1() {
    global $grid_attributes;

    $grid_display = [
        'show_cat' => array(
            'type' => 'boolean',
            'default' => true,
        ),
        'show_author' => array(
            'type' => 'boolean',
            'default' => true,
        ),
        'show_views' => array(
            'type' => 'boolean',
            'default' => true,
        ),
        'show_likes' => array(
            'type' => 'boolean',
            'default' => true,
        ),
        'show_comment_count' => array(
            'type' => 'boolean',
            'default' => true,
        ),
        'show_date' => array(
            'type' => 'boolean',
            'default' => true,
        ),
        'date_type' => array(
            'type' => 'string',
        ),
        'custom_date_type' => array(
            'type' => 'string',
        ),
    ];

    $grid_attributes = array_merge( $grid_attributes, $grid_display);

    register_block_type( 'gum/full-grid-1', array(
        'attributes' => $grid_attributes,
        'render_callback' => 'gum_render_full_grid_1_html',
    ) );
}
add_action('init', 'register_full_grid_1');

function gum_render_full_grid_1_html( $attributes ) {
    global $other_mapping;
    $options = [
    'dynamic_element_type' => '_full_block_1',
    'id' => '',
    'gum_grid_title' =>'', 
    'gum_grid_title_link' => '',
    'posts_per_page' => 5,
    'post_sort_by' => '',
    'gum_post_offset' => '',
    'category_id' => 0,
    'multi_cat_filter' => '', 
    'multi_tag_filter' => '',
    'multi_author_filter' => '',
    'post_type_filter' => '',
    'className' => '',
    'block_id' => '',
    'show_cat' => '',
    'show_date' => '',
    'show_author' => '',
    'show_views' => '',
    'show_likes' => '',
    'show_comment_count' => '',
    'date_type' => 'date_ago',
    ];
    foreach($options as $key=>$value){
        if(!empty($attributes[$key])) $options[$key] = $attributes[$key];
    }
    foreach($other_mapping as $js_key => $option_key){
        if(!empty($attributes[$js_key])) $options[$option_key] = $attributes[$js_key];
    }
    
	$data =  gum_html::full_block_1_html($options);
	if(!empty($data['html'])) return $data['html'];

}