<?php
if(!function_exists("gum_theme_options_nav")) :
function gum_theme_options_nav(){
	$main_options = array(
		'general' => array(
				'label' => 'General',
				'icon' => '',
				'class' => '',
				'sections' => array(
					'header_settings' => array(
						'label' => 'Header',
						'icon' => '',
						'class' => '',
					),
					'logo_settings' => array(
						'label' => 'Favicon/Logos',
						'icon' => '',
						'class' => '',
					),
					'footer_settings' => array(
						'label' => 'Footer',
						'icon' => '',
						'class' => '',
					),
					'social_url' => array(
						'label' => 'Social site urls',
						'icon' => '',
						'class' => '',
					),
					'post_view_count' => array(
						'label' => 'Post view counter',
						'icon' => '',
						'class' => '',
					),
					'post_likes' => array(
						'label' => 'Post likes',
						'icon' => '',
						'class' => '',
					),
					'general_misc' => array(
						'label' => 'Misc',
						'icon' => '',
						'class' => '',
					),
				),
		),
		'layout_settings' => array(
				'label' => 'Layout settings',
				'icon' => '',
				'class' => '',
				'sections' => array(
					'post_global_settings' => array(
						'label' => 'Single Post',
						'icon' => '',
						'class' => '',
					),
					'category_global_settings' => array(
						'label' => 'Category',
						'icon' => '',
						'class' => '',
					),
					'blog_global_settings' => array(
						'label' => 'blog',
						'icon' => '',
						'class' => '',
					),
					'sidebar_global_settings' => array(
						'label' => 'Sidebar',
						'icon' => '',
						'class' => '',
					),

				),
		),
		'theme_colors' => array(
				'label' => 'Theme Colors',
				'icon' => '',
				'class' => '',
				'sections' => array(
					'theme_colors_general' => array(
						'label' => 'General',
						'icon' => '',
						'class' => '',
					),
					'theme_colors_header' => array(
						'label' => 'Header',
						'icon' => '',
						'class' => '',
					),
					'theme_colors_post' => array(
						'label' => 'Post',
						'icon' => '',
						'class' => '',
					),
					'theme_colors_footer' => array(
						'label' => 'Footer',
						'icon' => '',
						'class' => '',
					),
				),


		),
		'typography' => array(
				'label' => 'Typography',
				'icon' => '',
				'class' => '',
				'sections' => array(
					'typography_general' => array(
						'label' => 'General',
						'icon' => '',
						'class' => '',
					),
					'typography_header' => array(
						'label' => 'Header',
						'icon' => '',
						'class' => '',
					),
					'typography_post' => array(
						'label' => 'Post',
						'icon' => '',
						'class' => '',
					),
					'typography_footer' => array(
						'label' => 'Footer',
						'icon' => '',
						'class' => '',
					),
				),
		),
		
		'advance' => array(
				'label' => 'Advance',
				'icon' => '',
				'class' => '',
				'sections' => array(
					'custom_css' => array(
						'label' => 'Custom CSS',
						'icon' => '',
						'class' => '',
					),
					'custom_js' => array(
						'label' => 'Javascript',
						'icon' => '',
						'class' => '',
					),
					'import_export' => array(
						'label' => 'import/export',
						'icon' => '',
						'class' => '',
					),

				),
		),

	);

	return $main_options;
}
endif;

if(!function_exists("gum_theme_options_section")) :
function gum_theme_options_section(){

	global $date_format;
	
	$yes_no = array(
		0 => 'No',
		1 => 'Yes'
	);
	$sidebar_options = array();
	if(function_exists("gum_sidebars")){
		 $sidebars = gum_sidebars();
		 foreach($sidebars as $sidebar) $sidebar_options[$sidebar['id']] = $sidebar['name'];
	}

	$date_format = GumHelper::get_date_formate();

	$cache_time = GumHelper::get_cache_time();

	$sections = array();

	/** General **/

	// General - header
	include("inc/general/header.php");

	// General - social sites
	include("inc/general/social_sites.php");

	// General - Favicon / Logo
	include("inc/general/logo_favi.php");

	// General - footer
	include("inc/general/footer.php");
	
	// General - view count
	include("inc/general/post_view_count.php");
	
	// General - Post likes
	include("inc/general/post_likes.php");

	// General - misc
	include("inc/general/misc.php");

	//Layout - Post settings
	include("inc/layout/post.php");

	//Layout - Category settings
	include("inc/layout/category.php");

	//Layout - Blog settings
	include("inc/layout/blog.php");

	//Layout - sidebar settings
	include("inc/layout/sidebar.php");

	/** Theme colors */
	include("inc/colors/general.php");
	include("inc/colors/header.php");
	include("inc/colors/post.php");
	include("inc/colors/footer.php");
	include("inc/advance/advance.php");
	
	
	include("inc/typography/general.php");
	include("inc/typography/header.php");
	include("inc/typography/post.php");
	include("inc/typography/footer.php");

	return $sections;
}
endif;