<?php

function gumtheme_reg_widget_about_me(){
    register_widget('gumtheme_widget_about_me');
}
add_action('widgets_init', 'gumtheme_reg_widget_about_me');

class gumtheme_widget_about_me extends WP_Widget{

    public $fields = array(

        array(
            'id' => 'profile_image',
            'html_id' => 'profile_image',
            'label' => 'Image',
            'desc' => 'Add your profile pic',
            'input_type' => 'media_upload',
            'value' => ''
        ),
        array(
            'id' => 'about_text',
            'html_id' => 'about_text',
            'input_type'=>'textarea',
            'label'=>'About Text',
            'value'=>"",
            'wrapper_class' => '',
            'label_class' => '',
            'input_class'=>"",
            'desc'=> "",
            'error_message'=> "",
            'validate' => '',
            'process' => "",
            'horizontal_field'=>false
        ),        
    );

    function __construct(){
        $widget_options = array( 
            'classname' => 'gumtheme_about_me',
            'description' => __('Gumthemes About Me')
        );
        parent::__construct('gumtheme-about-me', __('Gumthemes - About me'), $widget_options);
    }

    function widget($args, $instance){
        extract($args);

        if(!empty($before_widget)) echo $before_widget;

		    Gum_widget_html::Gumtheme_about_me($this->fields, $instance);

        if(!empty($after_widget))  echo $after_widget;
    }

    function update($new_instance, $old_instance) {

        $instance = $old_instance;

		foreach($this->fields as $field){

			$raw_id = $field['id'];

			if(isset($new_instance[$raw_id])) $instance[$raw_id] = $new_instance[$raw_id];
		}

        return $instance;
    }
    function form($instance) {

		foreach($this->fields as $field){

			if(!empty($instance[$field['id']])) $field['value'] = $instance[$field['id']];

			$meta_object = $field['input_type'];

			$field['id'] = $this->get_field_name($field['id']);
			$field['html_id'] = $this->get_field_id($field['id']);

			echo Gum_Be_Widget_Html::$meta_object($field);
        }
        

    }
}
