<?php

/***** Register Widgets *****/

function gum_register_ad_widget() {
	register_widget('gum_ad_widget');
}
add_action('widgets_init', 'gum_register_ad_widget');


class gum_ad_widget extends WP_Widget {

	public $fields = array();
    function __construct() {
    	global $gumtheme_ads;
    	$this->fields[] = array(
							'id' => 'title',
							'html_id' => 'title',
							'input_type'=>'text',
							'label'=>'Title',
							'value'=>"",
							'wrapper_class' => 'gum_title',
							'label_class' => '',
							'input_class'=>"",
							'desc'=> "Optional title",
							'error_message'=> "",
							'validate' => '',
							'process' => "",
							'horizontal_field'=>false
						);
		if(empty($gumtheme_ads['sidebar']['enable_sidebar_ad'])){
			$this->fields[] = array(
							'id' => 'desc',
							'html_id' => 'desc',
							'input_type'=>'desc',
							'class' => 'alert alert-danger',
							'text'=>'Sidebar ad is not enabled. This Widget will not display anything.',
					);
		}


        $widget_ops = array('classname' => 'gum-sidebar-ad', 'description' => __('', 'bloom-gumtheme'));
        parent::__construct('gum-ad', __('GumThemes - Ad', 'bloom-gumtheme'), $widget_ops);
    }
    function widget($args, $instance) {
		extract($args);
		if(!empty($before_widget)) echo $before_widget;

		Gum_widget_html::ad($this->fields, $instance);

       if(!empty($after_widget))  echo $after_widget;
    }
    function update($new_instance, $old_instance) {

        $instance = $old_instance;
		foreach($this->fields as $field){
			$raw_id = $field['id'];
			$field['id'] = $this->get_field_name($field['id']);

			if(isset($new_instance[$raw_id])) $instance[$raw_id] = $new_instance[$raw_id];
		}

        return $instance;
    }
    function form($instance) {

       //$instance = wp_parse_args((array) $instance, $defaults);

		foreach($this->fields as $field){

			if(!empty($instance[$field['id']])) $field['value'] = $instance[$field['id']];

			$meta_object = $field['input_type'];

			$field['id'] = $this->get_field_name($field['id']);
			$field['html_id'] = $this->get_field_id($field['id']);

			echo Gum_Be_Widget_Html::$meta_object($field);
		}

    }
}