<?php

/***** Register Widgets *****/

function gum_register_social_counter_widget() {
	register_widget('gum_social_counter_widget');
}
add_action('widgets_init', 'gum_register_social_counter_widget');


class gum_social_counter_widget extends WP_Widget {

	public $fields = array(
						// hidden id
						array(
							'id' =>'gum_widget_id',
							'input_type' => 'id',
				 			'value' => '',
						),
						array(
							'id' => 'title',
							'html_id' => 'title',
							'input_type'=>'text',
							'label'=>'Title',
							'value'=>"Follow Us",
							'wrapper_class' => 'gum_title',
							'label_class' => '',
							'input_class'=>"",
							'desc'=> "",
							'error_message'=> "",
							'validate' => '',
							'process' => "",
							'horizontal_field'=>false
						),
						array(
							'id' => 'social_sites',
							'html_id' => 'social_sites',
							'input_type'=>'social_checkbox',
							'label'=>'Sites',
							'value'=>"",
							'wrapper_class' => 'gum_social_counter_sites',
							'label_class' => '',
							'input_class'=>"",
							'desc'=> "",
							'error_message'=> "",
							'validate' => '',
							'process' => "",
							'horizontal_field'=>false
						),
						array(
							'id' =>'',
				 			'tag' => 'div',
				 			'input_type'=>'div_open',
				 			'title' => 'Style',
				 			'inner_div' => true,
						),
						array(
							'id' => 'style',
							'html_id' => 'style',
							'input_type'=>'select',
							'select_options' => array('gum-sc-style1' => "Style 1", "gum-sc-style2"=>"Style 2"),
							'label'=>'Style',
							'value'=>"gum-sc-style1",
							'wrapper_class' => 'gum_social_counter_widget',
							'label_class' => '',
							'input_class'=>"",
							'desc'=> "",
							'error_message'=> "",
							'validate' => '',
							'process' => "",
							'horizontal_field'=>false

						),
						array(
							'id' => 'title_color',
							'html_id' => 'title_color',
							'input_type'=>'text',
							'label'=>'Title color',
							'value'=>"",
							'placeholder' => "#333333",
							'wrapper_class' => '',
							'label_class' => '',
							'input_class'=>"",
							'desc'=> "",
							'error_message'=> "",
							'validate' => '',
							'process' => "",
							'horizontal_field'=>false
						),
						array(
							'id' =>'',
				 			'tag' => 'div',
				 			'input_type'=>'div_close',
				 			'inner_div' => true,
						),
					);
    function __construct() {
        $widget_ops = array('classname' => 'gum-social-counter', 'description' => __('Social counter', 'bloom-gumtheme'));
        parent::__construct('gum-social-counter', __('GumThemes - Social Counter', 'bloom-gumtheme'), $widget_ops);
    }
    function widget($args, $instance) {
		extract($args);
		if(!empty($before_widget)) echo $before_widget;

		Gum_widget_html::social_counter($this->fields, $instance);

       if(!empty($after_widget))  echo $after_widget;
    }
    function update($new_instance, $old_instance) {

        $instance = $old_instance;
		foreach($this->fields as $field){
			$raw_id = $field['id'];
			$field['id'] = $this->get_field_name($field['id']);

			if(isset($new_instance[$raw_id])) $instance[$raw_id] = $new_instance[$raw_id];
		}

        return $instance;
    }
    function form($instance) {

       //$instance = wp_parse_args((array) $instance, $defaults);

		foreach($this->fields as $field){

			if(!empty($instance[$field['id']])) $field['value'] = $instance[$field['id']];

			$meta_object = $field['input_type'];

			$field['id'] = $this->get_field_name($field['id']);
			$field['html_id'] = $this->get_field_id($field['id']);

			echo Gum_Be_Widget_Html::$meta_object($field);
		}

    }
}