<?php

/***** Register Widgets *****/

function gum_register_view_posts_widget() {
	register_widget('gum_view_posts_widget');
}
add_action('widgets_init', 'gum_register_view_posts_widget');


class gum_view_posts_widget extends WP_Widget {

	public $fields = array();
	
    function __construct() {
	    global $widget_categories;

	    $this->fields = get_common_widget_fields();
		$this->fields['title']['value'] = "Popular Posts";
		$this->fields['show_hide']['id'] = "hide_view_count";
		$this->fields['show_hide']['html_id'] = "hide_view_count";
		$this->fields['show_hide']['label'] = "Hide views count";
	    unset($this->fields["sortby"]);
	    
	    $widget_ops = array('classname' => 'gum-view-posts', 'description' => __('Popular posts by view counts', 'bloom-gumtheme'));
        parent::__construct('gum-view-posts', __('GumThemes - Posts by views', 'bloom-gumtheme'), $widget_ops);
    }
    function widget($args, $instance) {
		extract($args);
		if(!empty($before_widget)) echo $before_widget;

		Gum_widget_html::widget_posts($this->fields, $instance, "view_count");

       if(!empty($after_widget))  echo $after_widget;
    }
    function update($new_instance, $old_instance) {

        $instance = $old_instance;
		foreach($this->fields as $field){
			$raw_id = $field['id'];
			$field['id'] = $this->get_field_name($field['id']);

			if(isset($new_instance[$raw_id])) $instance[$raw_id] = $new_instance[$raw_id];
		}

        return $instance;
    }
    function form($instance) {

       //$instance = wp_parse_args((array) $instance, $defaults);

		foreach($this->fields as $field){

			if(!empty($instance[$field['id']])) $field['value'] = $instance[$field['id']];

			$meta_object = $field['input_type'];

			$field['id'] = $this->get_field_name($field['id']);
			$field['html_id'] = $this->get_field_id($field['id']);

			echo Gum_Be_Widget_Html::$meta_object($field);
		}

    }
}