<?php

if ( !function_exists('gumError') ):

	function gumError($error, $html=true){

		if(!empty(WP_DEBUG)) {

			if($html) echo "<div class='alert alert-danger'>";

			if(is_array($error) || is_object($error)){
				echo "<pre>";
				var_dump($error);
				echo "</pre>";
			}
			else echo $error;

			if($html) echo "</div>";

		}
	}
endif;

if ( ! function_exists( 'gum_post_date' ) ) :
/**
 * Prints HTML with current post-date/time.
 */
function gum_post_date() {
	$time_string = '<time class="entry-date published updated" datetime="%1$s">%2$s</time>';
	if ( get_the_time( 'U' ) !== get_the_modified_time( 'U' ) ) {
		$time_string = '<time class="entry-date published" datetime="%1$s">%2$s</time>';
	}

	$time_string = sprintf( $time_string,
		esc_attr( get_the_date( 'c' ) ),
		esc_html( get_the_date() ),
		esc_attr( get_the_modified_date( 'c' ) ),
		esc_html( get_the_modified_date() )
	);

	$posted_on = sprintf(
		esc_html_x( 'Posted on %s', 'post date', 'bloom-gumtheme' ),
		'<a href="' . esc_url( get_permalink() ) . '" rel="bookmark">' . $time_string . '</a>'
	);

	$comments_count = wp_count_comments();
	 $comments = '';
 	if($comments_count->approved > 0 ){
	 	 if($comments_count->approved == 1 ) $comment_text = 'comment';
	 	 else $comment_text = 'comments';
	 	 $comments = '<span class="comment"><a href="'.get_permalink().'">'.$comments_count->approved.' '.$comment_text.'</a></span>';

	}


	echo '<span class="posted-on">' . $posted_on . '</span><span class="post-comment">'.$comments.'</span>'; // WPCS: XSS OK.

}
endif;

if ( ! function_exists( 'gum_get_postmeta' ) ) :
/**
 * Prints HTML with meta information for the current post-date/time and author.
 */
function gum_get_postmeta() {
	$time_string = '<time class="entry-date published updated" datetime="%1$s">%2$s</time>';
	if ( get_the_time( 'U' ) !== get_the_modified_time( 'U' ) ) {
		$time_string = '<time class="entry-date published" datetime="%1$s">%2$s</time>';
	}

	$time_string = sprintf( $time_string,
		esc_attr( get_the_date( 'c' ) ),
		esc_html( get_the_date() ),
		esc_attr( get_the_modified_date( 'c' ) ),
		esc_html( get_the_modified_date() )
	);

	$posted_on = sprintf(
		esc_html_x( 'Posted on %s', 'post date', 'bloom-gumtheme' ),
		'<a href="' . esc_url( get_permalink() ) . '" rel="bookmark">' . $time_string . '</a>'
	);

	$byline = sprintf(
		esc_html_x( 'by %s', 'post author', 'bloom-gumtheme' ),
		'<span class="author vcard"><a class="url fn n" href="' . esc_url( get_author_posts_url( get_the_author_meta( 'ID' ) ) ) . '">' . esc_html( get_the_author() ) . '</a></span>'
	);

	$comments_count = wp_count_comments();
	$comments = '';
 	if($comments_count->approved > 0 ){
	 	 if($comments_count->approved == 1 ) $comment_text = 'comment';
	 	 else $comment_text = 'comments';
	 	 $comments = '<span class="comment"><a href="'.get_permalink().'">'.$comments_count->approved.' '.$comment_text.'</a></span>';

	}


	return '<span class="posted-on">' . $posted_on . '</span><span class="byline"> ' . $byline . '</span> '.$comments; // WPCS: XSS OK.

}
endif;


if ( ! function_exists( 'gum_theme_pagination' ) ) :
	/***
		*** Pageination
	***/
	function gum_theme_pagination($echo = true, $custom_query= false, $pages = '', $range = 2)
	{
	     $showitems = ($range * 2)+1;

	     global $paged;
	     if(empty($paged)) $paged = 1;

	     if($pages == '')
	     {
	         if(empty($custom_query))global $wp_query;
	         else $wp_query = $custom_query;
	         $pages = $wp_query->max_num_pages;
	         if(!$pages)
	         {
	             $pages = 1;
	         }
	     }
	     if(1 != $pages)
	     {

	        $html = "<nav><ul class='pagination pagination-sm'>";
	        if($paged > 2 && $paged > $range+1 && $showitems < $pages) $html .= "<li><a href='".get_pagenum_link(1)."'>&laquo;</a></li>";
	        if($paged > 1 && $showitems < $pages) $html .= "<li><a href='".get_pagenum_link($paged - 1)."'>&lsaquo;</a></li>";

	        for ($i=1; $i <= $pages; $i++)
	        {
	            if (1 != $pages &&( !($i >= $paged+$range+1 || $i <= $paged-$range-1) || $pages <= $showitems ))
	            {
	                $html .= ($paged == $i)? "<li class='active'><span class='current'>".$i."</span><li>":"<li><a href='".get_pagenum_link($i)."' class='inactive' >".$i."</a></li>";
	            }
	        }

	        if ($paged < $pages && $showitems < $pages) $html .= "<li><a href='".get_pagenum_link($paged + 1)."'>&rsaquo;</a></li>";
	        if ($paged < $pages-1 &&  $paged+$range-1 < $pages && $showitems < $pages) $html .= "<li><a href='".get_pagenum_link($pages)."'>&raquo;</a></li>";
	        $html .= "</ul></nav>\n";

	        if($echo) echo $html;
	        else return $html;
	     }
	}
endif;