<?php
	
	/**
 * @param string $output - is empty !!!
 * @param $atts
 * @param bool $content
 * @param bool $tag
 * @return mixed
 */
function gum_gallery_shortcode( $output = '', $attr, $content = false, $tag = false ) {
	
	 global $post;

    if (isset($attr['orderby'])) {
        $attr['orderby'] = sanitize_sql_orderby($attr['orderby']);
        if (!$attr['orderby'])
            unset($attr['orderby']);
    }

    extract(shortcode_atts(array(
        'order' => 'ASC',
        'orderby' => 'menu_order ID',
        'id' => $post->ID,
        'itemtag' => 'dl',
        'icontag' => 'dt',
        'captiontag' => 'dd',
        'columns' => 3,
        'size' => 'thumbnail',
        'include' => '',
        'exclude' => ''
    ), $attr));

    $id = intval($id);
    if ('RAND' == $order) $orderby = 'none';
	
    if (!empty($include)) {
        $include = preg_replace('/[^0-9,]+/', '', $include);
        $_attachments = get_posts(array('include' => $include, 'post_status' => 'inherit', 'post_type' => 'attachment', 'post_mime_type' => 'image', 'order' => $order, 'orderby' => $orderby));

        $attachments = array();
        foreach ($_attachments as $key => $val) {
            $attachments[$val->ID] = $_attachments[$key];
        }
    }

    if (empty($attachments)) return '';

	
    // Here's your actual output, you may customize it to your need
    $output = "<div class=\"slideshow-wrapper\">\n";
    $output .= "<div class=\"preloader\"></div>\n";
    $output .= '<div class="fotorama"
		data-allowfullscreen="true"
		data-width="780"
		data-ratio="3/2"
		data-nav="thumbs"
		data-thumbheight="48">';

    // Now you loop through each attachment
    foreach ($attachments as $id => $attachment) {
        
		$large_img_url_array = wp_get_attachment_image_src($id, 'gum_780X468', true);
		$thumb_url_small_array = wp_get_attachment_image_src($id, 'gum_150X90', true);
		$output .= '<a href="'.$large_img_url_array[0].'"><img src="'.$thumb_url_small_array[0].'" width="'.$thumb_url_small_array[0].'" height="'.$thumb_url_small_array[0].'"></a>';

    }

    $output .= "</div>\n";
    $output .= "</div>\n";

    return $output;

}

add_filter( 'post_gallery', 'gum_gallery_shortcode', 10, 4 );

	
	
	//http://wordpress.stackexchange.com/questions/182821/add-custom-fields-to-wp-native-gallery-settings
	add_action('print_media_templates', function(){
?>
<script type="text/html" id="tmpl-custom-gallery-setting">
   <div style="clear:both;"></div>
  
    <h3>Gumthemes Gallery Settings</h3>

    <label class="setting">
        <span><?php _e('Gallery title'); ?></span>
        <input type="text" value="" data-setting="gum_gallery_title" style="float:left;">
    </label>

    <label class="setting">
      <span><?php _e('Gallery type'); ?></span>
      <select data-setting="gum_gallery_type">
        <option value=""> Default </option>
      </select>
    </label>
</script>

<script>

    jQuery(document).ready(function()
    {
        _.extend(wp.media.gallery.defaults, {
        gum_gallery_title: '',
        gum_gallery_type: '',
        });

        wp.media.view.Settings.Gallery = wp.media.view.Settings.Gallery.extend({
        template: function(view){
          return wp.media.template('gallery-settings')(view)
               + wp.media.template('custom-gallery-setting')(view);
        }
        });

    });

</script>
<?php

});