<?php

class Gum_block extends Gum_widget_html{

	public static $more_text = '...';

	public function __construct()
	{

	}

	public static function get_default_args($options, $global_settings){
		/**
		* Default settings depend on theme options. global setting.
		* fallback of default values, if theme options are not saved, below fields will have value of 2 (default)
		* So we are creating fallback array, if theme options not set, check below array for the value.
		*/

		$args = array ();

			foreach($global_settings as $key => $default_value){

				$args[$key] = PbHelper::get_local_global_setting($key, $options, $default_value);
			}

			/*if($options['grid_date_type'] == 2){
				global $gumtheme_options;
				if(isset($gumtheme_options['grid_custom_date_format'])) $args['grid_custom_date_format'] =  $gumtheme_options['grid_custom_date_format'];
			}
			*/
		return $args;
	}

	public static function get_args($grid_args, $block_defaults){

		$args = array ();

		foreach($block_defaults as $key => $default_value){

			if(isset($grid_args[$key])) $args[$key] = $grid_args[$key];
			else $args[$key] = $default_value;
		}

		return $args;
	}
	public static function get_featured_image($post_id, $image_size){
		global $gumtheme_options;
		$img_src = '';
		if ( has_post_thumbnail($post_id ) ) {
			$post_image = wp_get_attachment_image_src( get_post_thumbnail_id( $post_id ), $image_size );
			$img_src = $post_image[0];
		}
		elseif(!empty($gumtheme_options['default_image'])){
			if(!empty($gumtheme_options['default_image_attachment_id'])){
				$post_image = wp_get_attachment_image_src( $gumtheme_options['default_image_attachment_id'], $image_size );
				$img_src = $post_image[0];
			}
			else $img_src = $gumtheme_options['default_image']; 
		}

		return $img_src;
	}
	public static function get_cat_class($post_id=null){

		$cat_class = '';
		if($post_id) $post_categories = get_the_category( $post_id );
		else $post_categories = get_the_category();

		$last_cat_id = 0;
		if(!empty($post_categories)){
			$index = count($post_categories) - 1;
			if(!empty($post_categories[$index]->term_id))$last_cat_id = $post_categories[$index]->term_id;

		}

		$cat_class =  "gum-block-cat-$last_cat_id";

		return $cat_class;

	}
	public static function block_cat_html($post_id,$categ="gum-post-cat",$limit=0){

		$cat_html = '';
		$count=0;
		$post_categories = get_the_category( $post_id );
		if(!empty($post_categories)){
			$cat_html .= "<ul class='$categ'>";
			foreach($post_categories as $post_category){
				if($limit != 0 && $count < $limit){
					$cat = get_category( $post_category );
					$cat_html .= '<li><a href="'.get_category_link($cat->term_id).'">'.$cat->name.'</a></li>';
				}
				else if($limit == 0){
					$cat = get_category( $post_category );
					$cat_html .= '<li><a href="'.get_category_link($cat->term_id).'">'.$cat->name.'</a></li>';
				}
			$count++;
			}

			$cat_html .= '</ul>';
		}

		return $cat_html;

	}
	public static function get_date($grid_show_date, $grid_date_type){


		$post_date = '';
		if($grid_show_date == 1){
			if($grid_date_type == 'date_ago'){
				$post_date = human_time_diff( get_the_date('U'), current_time('timestamp') ) .' '. __('ago', 'bloom-gumtheme');
			}
			else{
				$default_wordpress_date_format =  get_option( 'date_format' );
				if(strlen(trim($default_wordpress_date_format)) <= 0) $default_wordpress_date_format = 'M j, Y';
				$post_date = get_the_date($default_wordpress_date_format);
			}


		}

		return $post_date;

	}
	public static function get_post_likes_count($post_id, $show, $default_count=false,$likes='likes'){
		global $gumtheme_options;
		$html = '';
		
		if(!GumHelper::is_post_likes_enable()) return $html;

		$icon = GumHelper::get_likes_icon();
			
		
		if($default_count){
			if($default_count > 0  && $show == 1) $html = "<li class='gum-block-likes-count'>$icon ".GumHelper::thousandsCurrencyFormat($default_count)." ".$likes."</li>";
		}else{
			global $GUM_Postlike;			

			if(isset($GUM_Postlike) && $show == 1){
				$count = $GUM_Postlike->get_likes_count($post_id);


				if($count > 0) $html = "<li class='gum-block-likes-count'>$icon ".GumHelper::thousandsCurrencyFormat($count)." ".$likes."</li>";
			}

		}
		return $html;
	}
	public static function get_post_Mask_likes_count($post_id, $show, $default_count=false,$likes='likes'){
		global $gumtheme_options;
		$html = '';
		
		if(!GumHelper::is_post_likes_enable()) return $html;

		$icon = GumHelper::get_likes_icon();
			
		
		if($default_count){
			if($default_count > 0  && $show == 1) $html = "<p class='gum-block-likes-count'>$icon ".GumHelper::thousandsCurrencyFormat($default_count)." ".$likes."</p>";
		}else{
			global $GUM_Postlike;
			if(isset($GUM_Postlike) && $show == 1){

				$count = $GUM_Postlike->get_likes_count($post_id);

				if($count > 0) $html = "<p class='gum-block-likes-count'>$icon ".GumHelper::thousandsCurrencyFormat($count)." ".$likes."</p>";
			}

		}
		return $html;
	}
	public static function get_post_view_count($post_id, $show, $default_count=false, $posts_view_count,$views='views'){
		global $gumtheme_options;
		
		$html = '';
		
		if(!GumHelper::is_post_count_enable()) return $html;
		
		
		
		if(!empty($show)){
			
			$icon = GumHelper::get_postviews_icon();
			
					
			if(!empty($default_count)){
				
				$html = "<li class='gum-block-view-count'>$icon $default_count $views</li>";
			}else{
				
				if(isset($posts_view_count[$post_id])){
					$html = "<li class='gum-block-view-count'>$icon ".GumHelper::thousandsCurrencyFormat($posts_view_count[$post_id])." ".$views."</li>";
				} else{
					global $GUM_Postcount;
					
					if(isset($GUM_Postcount)){
						$when=array( );
						$count = $GUM_Postcount->get_post_view_count($post_id, $when);
						
						if($count > 0) $html = "<li class='gum-block-view-count'>$icon ".GumHelper::thousandsCurrencyFormat($count)." ".$views."</li>";
					}
				}
			}
		}
			
		return $html;
	}

	public static function get_post_comment_count($post_id, $show,$comment='comment'){
		global $GUM_Postcount;
		$html = '';
		$num_comments = get_comments_number($post_id); // get_comments_number returns only a numeric value
		if($num_comments > 0 && $show == 1){

			$html = "<li class='gum-block-comment-count'><i class='fa fa-comment-o' aria-hidden='true'></i> $num_comments $comment</li>";
		}

		return $html;
	}
	public static function get_review_stars($value){

		$html = '';
		if(!empty($value) && (float) $value > 0 ){
			$html ='<div class="gum-star-rating-count">';
			$full_stars = 0;
			$half_stars = 0;
			if (strpos($value, '.') !== false) {
				$stars = explode('.', $value);

				$full_stars = $stars[0];
				$half_stars =  ".".$stars[1];

			}
			else{
				$full_stars =$value;
			}
			$star_count = 0;
			if(!empty($full_stars) && (int) $full_stars > 0 ){
				// if $full_stars is more than 5, make it 5 , we only have 5 stars
				if($full_stars > 5) $full_stars = 5;
				for($i=1; $i <= $full_stars; $i++){
					$html .='<i class="fa fa-star" aria-hidden="true"></i>';
					$star_count++;
				}
			}
			if($full_stars < 5){
				if(!empty($half_stars) && (float) $half_stars < 1 && (float) $half_stars > 0){
					if((float) $half_stars > .6){
						$html .='<i class="fa fa-star" aria-hidden="true"></i>';
					}
					else $html .='<i class="fa fa-star-half-o" aria-hidden="true"></i>';
					$star_count++;
				}
			}
			// Empty stars
			$empty_stars = 5 - $star_count;
			if($empty_stars > 0){
				for($i=1; $i <= $empty_stars; $i++){
					$html .='<i class="fa fa-star-o" aria-hidden="true"></i>';

				}
			}
			$html .= '</div><!-- gum-star-rating -->';

			return $html;
		}
		return false;
	}
	public static function get_post_review($post_id){
		$is_review_post = get_post_meta($post_id, 'gum_is_review_post', true);
		$review_html='';
		if(!empty($is_review_post) && $is_review_post != 'no'){
			$gum_post_review_total = (float) get_post_meta($post_id, 'gum_post_review_total', true);

			if($gum_post_review_total > 0){
				$review_html = self::get_review_stars($gum_post_review_total);

			}

		}
		return $review_html;
	}
	public static function fullGrid_inner_html($args ){
		$defaults = array(
			"post_permalink" => '',
			"image" => '',
			"post_title" => '',
			"post_cat_html" => '',
			"format" => '',
			"review_html" => '',
			"show_author" => '',
			"post_author" => '',
			"post_date" => '',
			"post_likes" => '',
			"post_views" => '',
			"post_comment_count" => '',
		);

		$args = wp_parse_args( $args, $defaults );
		extract($args);
		$image_class = '';
		if(!empty($image)) $image_class = 'gum_grid_link_img';
		$html ="<a href='$post_permalink' class='gum_grid_link $image_class' style='background-image: url(\"$image\");'></a>";
		
		if(!empty($format) && $format =='video') $html .= "<span class='post-play-btn'><i class='fa fa-play' aria-hidden='true'></i></span>";
		$html .= "<div class='gum_post_data'>";
		$html .= $post_cat_html;
		$html .= "<h3 class='p_title'><a href='$post_permalink'>$post_title</a></h3>";
			
			if($show_author == 1 || strlen($post_date) > 0) $html .= "<ul class='pull-left'>";
			if($show_author == 1){
				$auth_class = '';
				if(strlen($post_date) > 0) $auth_class = "divider";
				 $html .= "<li class='block-post-author $auth_class'>".$post_author."</li>";
			}
			$html .="<div class='tag'>";
			if(strlen($post_date) > 0) $html .= "<li class='block-date'>$post_date</li>";
			if(!empty($review_html)) $html .=  $review_html;
			$html .="</div>";
			if($show_author == 1 || strlen($post_date) > 0) $html .= "</ul>";

			if(strlen($post_likes) > 0 || strlen($post_views) > 0 || strlen($post_comment_count) > 0 ) $html .= "<ul class='pull-right'>";
			$html .= $post_likes;
			$html .= $post_views;
			$html .= $post_comment_count;
			if(strlen($post_likes) > 0 || strlen($post_views) > 0 || strlen($post_comment_count) > 0 )  $html .= "</ul>";

		$html .= "<div class='clearfix'></div>
					</div><!-- .gum_post_data -->";
		// remove line breaks
		$html = trim(preg_replace('/\s+/', ' ', $html));
		return $html;

	}
	public static function fullGrid_inner_html1($args ){
		$defaults = array(
			"post_permalink" => '',
			"image" => '',
			"post_title" => '',
			"post_cat_html" => '',
			"format" => '',
			"review_html" => '',
			"show_author" => '',
			"post_author" => '',
			"post_date" => '',
			"post_likes" => '',
			"post_views" => '',
			"post_comment_count" => '',
		);
		$args = wp_parse_args( $args, $defaults );
		extract($args);
		$image_class = '';
		if(!empty($image)) $image_class = 'gum_grid_link_img';
		$html ="<a href='$post_permalink' class='gum_grid_link $image_class' style='background-image: url(\"$image\");'></a>";
		$html .= $post_cat_html;
		if(!empty($format) && $format =='video') $html .= "<span class='post-play-btn'><i class='fa fa-play' aria-hidden='true'></i></span>";
		$html .= "<div class='gum_post_data'>
			<h3 class='p_title'><a href='$post_permalink'>$post_title</a></h3>";
			if(!empty($review_html)) $html .=  $review_html;
			if($show_author == 1 || strlen($post_date) > 0) $html .= "<ul class='pull-left'>";
			if($show_author == 1){
				$auth_class = '';
				if(strlen($post_date) > 0) $auth_class = "divider";
				 $html .= "<li class='block-post-author $auth_class'>".$post_author."</li>";
			}
			if(strlen($post_date) > 0) $html .= "<li class='block-date'>$post_date</li>";
			if($show_author == 1 || strlen($post_date) > 0) $html .= "</ul>";
			if(strlen($post_likes) > 0 || strlen($post_views) > 0 || strlen($post_comment_count) > 0 ) $html .= "<ul class='pull-right'>";
			$html .= $post_likes;
			$html .= $post_views;
			$html .= $post_comment_count;
			if(strlen($post_likes) > 0 || strlen($post_views) > 0 || strlen($post_comment_count) > 0 )  $html .= "</ul>";
		$html .= "<div class='clearfix'></div>
					</div><!-- .gum_post_data -->";
		// remove line breaks
		$html = trim(preg_replace('/\s+/', ' ', $html));
		$html ='<div class="single-post-banner">
          <div class="small-post-main">
              <img src="'.$image.'">
              '.$post_cat_html.'
            </div><!--small-post-main-->

            <div class="post-tile magin-top-10-big-size">
              <h6><a href="'.$post_permalink.'">'.$post_title.'</a></h6>
            </div><!--slide-title-->
        </div>';
		return $html;
	}


	public static function fullGrid_block_1($grid_args){

		$block_defaults = array (
 			'class' => '',
 			'show_cat' => 1,
			'show_date' => 1,
			'show_author' => 0,
			'show_views' => 0,
			'show_likes' => 0,
			'show_comment_count' => 0,
			'date_type' => 'date_ago',
			'title_word_count' => 60,
			'posts_view_count' => array(),

 		);
 		
 		// Parse $grid_args into an array and merge it with $defaults
		$args = self::get_args($grid_args, $block_defaults);

		extract($args);
		
		$post_id = get_the_ID();
		$html = '';
		if(!empty($post_id)){
			$img_src = self::get_featured_image($post_id, 'gum_780X468');
			$post_permalink = get_the_permalink();

			$number_words = $title_word_count;
			$post_title = wp_trim_words(get_the_title(), $number_words, self::$more_text);

			$post_date = self::get_date($show_date, $date_type);
			$review_html = self::get_post_review($post_id);
			$cat_html = '';
			if($show_cat == 1) $cat_html = gum_html::block_cat_html($post_id,'gum-post-cat',1);

			$cat_class = self::get_cat_class();

			$html = "<div class='col-sm-6 col-xs-12 fullgrid_block_1_wrapper $cat_class $class'>
						<div class='gum_post_fullgrid fullgrid_block_1'>";
						$inner_arg = array(
							"post_permalink" => $post_permalink,
							"post_title" => $post_title,
							"image" => $img_src,
							"post_cat_html" => $cat_html,
							"format" => get_post_format( $post_id ),
							"review_html" => $review_html,
							"show_author" => $show_author,
							"post_author" => get_the_author(),
							"post_date" => $post_date,
							"post_likes" => self::get_post_likes_count($post_id, $show_likes),
							"post_views" => self::get_post_view_count($post_id, $show_views, false, $posts_view_count),
							"post_comment_count" => self::get_post_comment_count($post_id, $show_comment_count),
						);
						$html .="<a href='$post_permalink' class='mask'></a>";
						$html .= self::fullGrid_inner_html($inner_arg );


						$html .= " </div> <!-- gum_large_grid -->
						</div> <!-- gum_grid_large -->";

				
		}
		return $html;
	}
	public static function fullGrid_block_2($grid_args){

		$block_defaults = array (
 			'class' => '',
 			'image' => '',
 			'show_cat' => 1,
			'show_date' => 1,
			'show_author' => 0,
			'show_views' => 0,
			'show_likes' => 0,
			'show_comment_count' => 0,
			'date_type' => 'date_ago',
			'title_word_count' => 20,
			'posts_view_count' => array(),

 		);

		// Parse $grid_args into an array and merge it with $defaults
		$args = self::get_args($grid_args, $block_defaults);
		extract($args);

		$post_id = get_the_ID();
		$html = '';
		if(!empty($post_id)){
			$img_src = self::get_featured_image($post_id, 'gum_350X210');
			
			$post_permalink = get_the_permalink();
			$number_words = $title_word_count;
			$post_title = wp_trim_words(get_the_title(), $number_words, self::$more_text);

			$post_date = self::get_date($show_date, $date_type);
			$review_html = self::get_post_review($post_id);
			$cat_html = '';
			if($show_cat == 1) $cat_html = gum_html::block_cat_html($post_id,'gum-post-cat',1);

			$cat_class = self::get_cat_class();

			$html = "<div class='col-sm-6 col-xs-6 fullgrid_block_2_wrapper $class $cat_class'>
					<div class='gum_post_fullgrid gum-smal-grid fullgrid_block_2 m_b_10'>";

					$inner_arg = array(
						"post_permalink" => $post_permalink,
						"post_title" => $post_title,
						"image" => $img_src,
						"post_cat_html" => $cat_html,
						"format" => get_post_format( $post_id ),
						"review_html" => $review_html,
						"show_author" => $show_author,
						"post_author" => get_the_author(),
						"post_date" => $post_date,
						"post_likes" => self::get_post_likes_count($post_id, $show_likes),
						"post_views" => self::get_post_view_count($post_id, $show_views, false, $posts_view_count),
						
						"post_comment_count" => self::get_post_comment_count($post_id, $show_comment_count),
					);
					$html .="<a href='$post_permalink' class='mask'></a>";
					$html .= self::fullGrid_inner_html($inner_arg );

					$html .= "</div><!-- gum-smal-grid -->
			</div>";



		}
		return $html;
	}
	public static function fullGrid_block_3($grid_args){

		$block_defaults = array (
 			'class' => '',
 			'image' => '',
 			'show_cat' => 1,
			'show_date' => 1,
			'show_author' => 0,
			'show_views' => 0,
			'default_views' => false,
			'default_likes' => false,
			'show_likes' => 0,
			'show_comment_count' => 0,
			'date_type' => 'date_ago',
			'title_word_count' => 60,
			'posts_view_count' => array(),

 		);

		
		// Parse $grid_args into an array and merge it with $defaults
		$args = self::get_args($grid_args, $block_defaults);

		extract($args);

		$post_id = get_the_ID();
		$html = '';
		if(!empty($post_id)){
			$img_src = self::get_featured_image($post_id, 'gum_350X210');
			$post_permalink = get_the_permalink();

			$number_words = $title_word_count;
			$post_title = wp_trim_words(get_the_title(), $number_words, self::$more_text);

			$post_date = self::get_date($show_date, $date_type);
			$review_html = self::get_post_review($post_id);
			$cat_html = '';
			if($show_cat == 1) $cat_html = gum_html::block_cat_html($post_id,'gum-post-cat',1);

			$cat_class = self::get_cat_class();

			$html = "<div class='fullgrid_block_3_wrapper $class $cat_class'>
					<div class='gum_post_fullgrid gum-smal-grid fullgrid_block_3 m_b_10'>";
					$inner_arg = array(
						"post_permalink" => $post_permalink,
						"image" => $img_src,
						"post_title" => $post_title,
						"post_cat_html" => $cat_html,
						"format" => get_post_format( $post_id ),
						"review_html" => $review_html,
						"show_author" => $show_author,
						"post_author" => get_the_author(),
						"post_date" => $post_date,
						"post_likes" => self::get_post_likes_count($post_id, $show_likes, $default_likes),
						"post_views" => self::get_post_view_count($post_id, $show_views, $default_views, $posts_view_count),
						
						"post_comment_count" => self::get_post_comment_count($post_id, $show_comment_count),
					);
					
					$html .= self::fullGrid_inner_html($inner_arg );

					$html .= "</div><!-- gum-smal-grid -->
			</div>";



		}
		return $html;
	}

	public static function carousel_block($grid_args){

 		$block_defaults = array (
 			'class' => '',
 			'show_cat' => 1,
			'show_date' => 1,
			'show_author' => 1,
			'show_views' => 0,
			'show_likes' => 0,
			'show_comment_count' => 0,
			'show_excerpt' => 1,
			'date_type' => 'date_ago',
			'title_word_count' => 60,
			'excerpt_word_count' => 20,
			'image_size' => 'gum_600X360',
			'row_class' => '',
			'read_more' => 0,
			'posts_view_count' => array(),
 		);

		// Parse $grid_args into an array and merge it with $defaults
		$args = self::get_args($grid_args, $block_defaults);


		extract($args);


		$post_id = get_the_ID();

		$html = '';
		if(!empty($post_id)){
			$img_src = self::get_featured_image($post_id, $image_size);
			$post_permalink = get_the_permalink();
			$number_words = $title_word_count;
			$post_title = wp_trim_words(get_the_title(), $number_words, self::$more_text);

			$post_date = self::get_date($show_date, $date_type);
			$review_html = self::get_post_review($post_id);
			$cat_html = '';
			if($show_cat == 1) $cat_html = gum_html::block_cat_html($post_id,'gum-post-cat',1);

			$cat_class = self::get_cat_class();

			$html = "<div class='col-sm-3 col-xs-3 gum_carousel_item_wrapper slick-slide $class $cat_class'>
					<div class='gum_carousel_item gum_post_fullgrid'>";

					$inner_arg = array(
						"post_permalink" => $post_permalink,
						"post_title" => $post_title,
						"show_title" => '1',
						"show_cat" => '1',
						"post_cat_html" => $cat_html,
						"image" => $img_src,
						"format" => get_post_format( $post_id ),
						"review_html" => $review_html,
						"show_author" => $show_author,
						"post_author" => get_the_author(),
						"post_date" => $post_date,
						"post_likes" => self::get_post_likes_count($post_id, $show_likes),
						"post_views" => self::get_post_view_count($post_id, $show_views, false, $posts_view_count),
						"post_comment_count" => self::get_post_comment_count($post_id, $show_comment_count),
					);
					$html .= self::fullGrid_inner_html1($inner_arg );

					$html .= "</div></div><!-- gum_carousel_item_wrapper -->";



		}
		return $html;

	}

	public static function full_width_block($grid_args){

		
 		$block_defaults = array (
 			'class' => '',
 			'show_cat' => 1,
			'show_date' => 1,
			'show_author' => 1,
			'show_views' => 0,
			'show_likes' => 0,
			'show_comment_count' => 0,
			'show_excerpt' => 1,
			'date_type' => 'date_ago',
			'title_word_count' => 60,
			'excerpt_word_count' => 20,
			'image_size' => 'full',
			'row_class' => '',
			'read_more' => 0,
			'posts_view_count' => array(),

 		);

		// Parse $grid_args into an array and merge it with $defaults
		$args = self::get_args($grid_args, $block_defaults);


		extract($args);
		$post_id = get_the_ID();

		$html = '';
		if(!empty($post_id)){
			$img_src = self::get_featured_image($post_id, $image_size);
			$post_permalink = get_the_permalink();
			$number_words = $title_word_count;
			$post_title = wp_trim_words(get_the_title(), $number_words, self::$more_text);

			$post_date = self::get_date($show_date, $date_type);
			$review_html = self::get_post_review($post_id);
			$cat_html = '';
			if($show_cat == 1) $cat_html = gum_html::block_cat_html($post_id,'gum-post-cat',1);
			$cat_class = self::get_cat_class();
			$html = "<div class='col-sm-12 gum_slider_item_wrapper slick-slide $class $cat_class'>
					<div class='gum_post_fullgrid gum_slider_item'>";
					$inner_arg = array(
						"post_permalink" => $post_permalink,
						"post_title" => $post_title,
						"image" => $img_src,
						"post_cat_html" => $cat_html,
						"format" => get_post_format( $post_id ),
						"review_html" => $review_html,
						"show_author" => $show_author,
						"post_author" => get_the_author(),
						"post_date" => $post_date,
						"post_likes" => self::get_post_likes_count($post_id, $show_likes),
						"post_views" => self::get_post_view_count($post_id, $show_views, false, $posts_view_count),
						"post_comment_count" => self::get_post_comment_count($post_id, $show_comment_count),

					);
					$html .= self::fullGrid_inner_html($inner_arg );

					$html .= "</div><!--gum_slider_item -->
			</div>";



		}
		return $html;

	}
	public static function slider_block($grid_args){
		$block_defaults = array (
 			'class' => '',
 			'show_cat' => 0,
			'show_mask' => 1,
			'show_date' => 0,
			'show_author' => 0,
			'show_views' => 0,
			'show_likes' => 0,
			'show_comment_count' => 0,
			'show_excerpt' => 0,
			'date_type' => 'date_ago',
			'show_title' => '1',
			'title_word_count' => 5,
			'excerpt_word_count' => 20,
			'image_size' => 'gum_400X240',
			'row_class' => '',
			'read_more' => 0,
			'posts_view_count' => array(),
			'slider_show_cat' => 0,
			'font_size_class' => ' ',
			'show_reviews' => 1,
 		);
 		global $gumtheme_options;
 		
		// Parse $grid_args into an array and merge it with $defaults
		$args = self::get_args($grid_args, $block_defaults);

		extract($args);

		$post_id = get_the_ID();
		$format = get_post_format( $post_id );
		$html = '';
		if(!empty($post_id)){

			$img_src = self::get_featured_image($post_id, $image_size);
			
			$post_permalink = get_the_permalink();

			$number_words = $title_word_count;
			$post_title = wp_trim_words(get_the_title(), $number_words, self::$more_text);

			$post_excerpt = wp_trim_words(get_the_excerpt(), $excerpt_word_count, self::$more_text);

			$post_date = self::get_date($show_date, $date_type);
			$review_html = self::get_post_review($post_id);
			$cat_html = '';
			if($show_cat == 1) $cat_html = gum_html::block_cat_html($post_id,' ',1);

			$likes_html = self::get_post_likes_count($post_id, $show_likes,false,' ');
			$mask_likes_html=self::get_post_Mask_likes_count($post_id, $show_likes);
			$views_html = self::get_post_view_count($post_id, $show_views, false, $posts_view_count,' ');
			$comment_count_html = self::get_post_comment_count($post_id, $show_comment_count,false,' ');

			$cat_class = self::get_cat_class();

		$html = "<div class='$class'>";

		$html .="<div class='small-posts'>                  
                      <div class='post'>
                        <div class='img-holder'>";   

        $html .="<div class='tag'>";
		if($slider_show_cat || $show_cat ) $html.="$cat_html";

		if($show_reviews) $html .=$review_html;

		$html .="</div>";
		$html .="<a href='$post_permalink'>
					<img src='$img_src' class='img-fluid' alt='$post_title'>
				  </a>
				</div>";

		if(!$slider_show_cat && $show_cat){
	        $html.="<ul>";
	        if($show_likes) $html .="$likes_html";
	        if($show_views) $html.="$views_html";
	        if($show_comment_count) $html.="$comment_count_html";

	        if($show_author == 1){
				$auth_class = '';
				if(strlen($post_date) > 0) $auth_class = "divider";
				$html .= "<li class='block-post-author $auth_class'><i class='fa fa-user'></i>".get_the_author()."</li>";
			}
	        if($show_date) $html.="<li class='gum-block-date'><i class='fa fa-calendar'></i> $post_date</li>";
	        $html.="</ul>";
    	}

        if($show_title)
            $html .="<h2 class='$font_size_class'><a href='$post_permalink'>$post_title</a></h2>";	

        if($show_excerpt) $html.="<p class='excerpt'>$post_excerpt</p>";
        if($read_more) $html .= "<a href='$post_permalink' class='gum-read-more'>".__('Read More', 'bloom-gumtheme')."</a>";
				            
				            $html .="
				          </div>				        
				    </div>";

		$html .="</div>";		

		}
		unset($args);
		return $html;
	}
	public static function block_1($grid_args){
		$block_defaults = array (
 			'class' => '',
 			'show_cat' => 1,
			'show_mask' => 1,
			'show_date' => 0,
			'show_author' => 0,
			'show_views' => 0,
			'show_likes' => 0,
			'show_comment_count' => 0,
			'show_excerpt' => 0,
			'date_type' => 'date_ago',
			'show_title' => '1',
			'title_word_count' => 10,
			'excerpt_word_count' => 20,
			'image_size' => 'gum_400X240',
			'row_class' => '',
			'read_more' => 0,
			'posts_view_count' => array(),
			'slider_show_cat' => 0,
			'font_size_class' => ' ',
			'show_reviews' => 0,
 		);
 		global $gumtheme_options;
 		
		// Parse $grid_args into an array and merge it with $defaults
		$args = self::get_args($grid_args, $block_defaults);

		extract($args);

		$post_id = get_the_ID();
		$format = get_post_format( $post_id );
		$html = '';
		if(!empty($post_id)){

			$img_src = self::get_featured_image($post_id, $image_size);
			
			$post_permalink = get_the_permalink();

			$number_words = $title_word_count;
			$post_title = wp_trim_words(get_the_title(), $number_words, self::$more_text);

			$post_excerpt = wp_trim_words(get_the_excerpt(), $excerpt_word_count, self::$more_text);

			$post_date = self::get_date($show_date, $date_type);
			$review_html = self::get_post_review($post_id);
			$cat_html = '';
			$cat_html = gum_html::block_cat_html($post_id,' ',1);

			$likes_html = self::get_post_likes_count($post_id, $show_likes);
			$mask_likes_html=self::get_post_Mask_likes_count($post_id, $show_likes);
			$views_html = self::get_post_view_count($post_id, $show_views, false, $posts_view_count);
			$comment_count_html = self::get_post_comment_count($post_id, $show_comment_count);

			$cat_class = self::get_cat_class();

		$html = "<div class='$class block-1-posts'>";

		$html .="<div class='small-posts'>                  
                      <div class='post'>";

        $html.="<div class='img-holder'>";
		
		$html.="<div class='tag'>";
		if($show_cat) $html .=$cat_html;
		if($show_reviews) $html .=$review_html;
		$html .="</div>";

		$html .="<a href='$post_permalink'>
					<img src='$img_src' class='img-fluid' alt='$post_title'>
				  </a>
				</div>";

		if(strlen($likes_html) > 0 || strlen($views_html) > 0 || strlen($comment_count_html) > 0 || $show_author == 1 || $show_date == 1)
        $html.="<ul>";

        if($show_likes) $html .="$likes_html";
        if($show_views) $html.="$views_html";
        if($show_comment_count) $html.="$comment_count_html";

        if($show_author == 1){
			$auth_class = '';
			if(strlen($post_date) > 0) $auth_class = "divider";
			$html .= "<li class='block-post-author $auth_class'><i class='fa fa-user'></i>".get_the_author()."</li>";
		}
        if($show_date) $html.="<li class='gum-block-date'><i class='fa fa-calendar'></i> $post_date</li>";
        if(strlen($likes_html) > 0 || strlen($views_html) > 0 || strlen($comment_count_html) > 0 || $show_author == 1 || $show_date == 1)
        $html.="</ul>";
    	

        if($show_title)
            $html .="<h2 class='$font_size_class'><a href='$post_permalink'>$post_title</a></h2>";	

        if($show_excerpt) $html.="<p class='excerpt'>$post_excerpt</p>";
        if($read_more) $html .= "<a href='$post_permalink' class='gum-read-more'>".__('Read More', 'bloom-gumtheme')."</a>";
				            
				            $html .="
				          </div>				        
				    </div>";

		$html .="</div>";		

		}
		unset($args);
		return $html;
	}
	public static function block_2($grid_args){

		$block_defaults = array (
 			'class' => 'col-xs-12',
			'image_size' => 'gum_150X90',
			'show_cat' => 1,
			'show_date' => 0,
			'show_author' => 0,
			'show_views' => 0,
			'show_likes' => 0,
			'show_comment_count' => 0,
			'show_excerpt' => 0,
			'date_type' => 'date_ago',
			'title_word_count' => 10,
			'excerpt_word_count' => 20,
			'row_class' => '',
			'read_more' => 0,
			'posts_view_count' => array(),
			'block_data_class' => ' col-md-6',
 		);
		
		// Parse $grid_args into an array and merge it with $defaults
		$args = self::get_args($grid_args, $block_defaults);

		extract($args);


		$post_id = get_the_ID();
		$format = get_post_format( $post_id );
		$html = '';
		if(!empty($post_id)){
			$img_src = self::get_featured_image($post_id, $image_size);
			$post_permalink = get_the_permalink();
			$number_words = $title_word_count;
			$post_title = wp_trim_words(get_the_title(), $number_words, self::$more_text);

			$post_date = self::get_date($show_date, $date_type);
			$review_html = self::get_post_review($post_id);
			$cat_html = '';
			if($show_cat == 1) $cat_html = gum_html::block_cat_html($post_id,'gum-post-cat',1);
			if($show_excerpt ==1) $post_excerpt = wp_trim_words(get_the_excerpt(), $excerpt_word_count, self::$more_text);
			
			$likes_html = self::get_post_likes_count($post_id, $show_likes);
			$views_html = self::get_post_view_count($post_id, $show_views, false, $posts_view_count);
			$comment_count_html = self::get_post_comment_count($post_id, $show_comment_count);
			
			$cat_class = self::get_cat_class();


			$html = "<div class='gum-block-2-wrapper $class $cat_class'>
						<div class='gum-block gum-block-2 $row_class'>";							
			
			$html .=" <div class='img-holder12'>
			<a href='$post_permalink' class='gum-block-post-img'>
				<img src='$img_src' alt= '$post_title' class='gum-p-img'/>";

			if(!empty($format) && $format =='video') $html .= "<span class='post-play-btn'><i class='fa fa-play' aria-hidden='true'></i></span>";

			$html .= "</a>";
			if(!empty($review_html)) $html .=  '<div class="tag2">'.$review_html.'</div>';
			$html .="</div>";
								
							
			$html .="<div class='gum-block-data $block_data_class'>

				<h2 class='gum-block-post-title'><a href='$post_permalink'>$post_title</a></h2>";
				

				if(strlen($likes_html) > 0 || strlen($views_html) > 0 || strlen($comment_count_html) > 0 || $show_author == 1 || strlen($post_date) > 0) $html .= "<ul class='small-block-lists'>";
				if($show_author == 1){
					$auth_class = '';
					if(strlen($post_date) > 0) $auth_class = "divider";
					$html .= "<li class='block-post-author $auth_class'><i class='fa fa-user'></i>".get_the_author()."</li>";
				}
				if(strlen($post_date) > 0) $html .= "<li class='block-date'><i class='fa fa-calendar'></i>$post_date</li>";

				$html .= $likes_html;
				$html .= $views_html;
				$html .= $comment_count_html;

				if(strlen($likes_html) > 0 || strlen($views_html) > 0 || strlen($comment_count_html) > 0 || $show_author == 1 || strlen($post_date) > 0) $html .= "</ul>";
				$html .= "<div class='clearfix'></div>";
				
				if($show_excerpt ==1) $html .= "<p>$post_excerpt</p>";
				if($read_more == 1) $html .= "<a href='$post_permalink' class='gum-read-more'>".__('Read More', 'bloom-gumtheme')."</a>";

			$html .= "</div><!-- .gum_post_data --><div class='clearfix'></div>
		</div><!-- gum-block -->
	</div>";
		}
		return $html;

	}
	public static function block_3($grid_args){
		$block_defaults = array (
 			'class' => 'col-sm-6',
 			'show_cat' => 1,
			'show_date' => 0,
			'show_author' => 0,
			'show_views' => 0,
			'show_likes' => 1,
			'show_comment_count' => 0,
			'show_excerpt' => 0,
			'date_type' => 'date_ago',
			'show_title' => 1,
			'title_word_count' => 10,
			'excerpt_word_count' => 20,
			'image_size' => 'gum_400X240',
			'row_class' => '',
			'read_more' => 0,
			'posts_view_count' => array(),
			'postid' => 0,
			'special' => 0,
			'title_class' => '',
			'show_reviews' => 0,
 		);
 		global $gumtheme_options;
 		
		// Parse $grid_args into an array and merge it with $defaults
		$args = self::get_args($grid_args, $block_defaults);

		extract($args);

		if($postid)	$post_id=$postid;
		else $post_id = get_the_ID();

		$format = get_post_format( $post_id );
		$html = '';
		if(!empty($post_id)){
			$mask_html = '';

			$img_src = self::get_featured_image($post_id, $image_size);
			$my_var1='LIKES';$my_var2='VIEWS';$my_var3='COMMENT';
			$post_permalink = get_the_permalink();

			$number_words = $title_word_count;
			$post_title = wp_trim_words(get_the_title($post_id), $number_words, self::$more_text);

			$post_excerpt = wp_trim_words(get_the_excerpt(), $excerpt_word_count, self::$more_text);

			$post_date = self::get_date($show_date, $date_type);
			$review_html = self::get_post_review($post_id);
			$cat_html = '';
			if($show_cat == 1) $cat_html = gum_html::block_cat_html($post_id,' ',1);

			if($special == 1){
				$my_var1='';$my_var2='';$my_var3='';
			}
			$likes_html = self::get_post_likes_count($post_id, $show_likes,false,$my_var1);
			$mask_likes_html=self::get_post_Mask_likes_count($post_id, $show_likes);
			$views_html = self::get_post_view_count($post_id, $show_views, false, $posts_view_count,$my_var2);
			$comment_count_html = self::get_post_comment_count($post_id, $show_comment_count,$my_var3);

			$cat_class = self::get_cat_class();

		$html = "<div class='$class'>";

		$html .="<div class='img-holder'>";

        

        $html .= "<div class='mask'><a class='mask2' href='$post_permalink'>$mask_likes_html</a><div class='content'>";
        if($show_cat) $html.="<div class='tag'>$cat_html</div>";
        $html.="<ul>";
        if($show_views) $html.="$views_html";
        if($show_comment_count) $html.="$comment_count_html";

        if($show_date) $html.="<li><i class='fa fa-calendar'></i> $post_date</li>";
        $html.="</ul>";

        if($show_reviews) $html .=$review_html;

        if($show_title)
            $html .="<h2 class='$title_class'><a href='$post_permalink'>$post_title</a></h2>";

        $html .="</div><!--content-->        				
        				</div>";
        

        $html .="<a href='$post_permalink'><img src='$img_src' class='img-fluid' alt='$post_title'>
				</a>
				</div><!--img-holder-->";
        

            if($show_excerpt) $html.="<p>$post_excerpt</p>";
        if($read_more == 1) $html .= "<a href='$post_permalink' class='gum-read-more'>".__('Read More', 'bloom-gumtheme')."</a>";
		$html .="</div>";		

		}
		return $html;
	}
	public static function block_4($args1,$type='main'){
		if($type == 'widget'){
			$args['postid']=$args1;
			$args['class'] = "";
			$args['show_cat'] = "1";
			$args['show_date'] = "0";
			$args['show_title'] = "1";
			$args['title_word_count'] = '4';
			$args['show_excerpt'] = "0";
			$args['read_more'] = "0";
			$args['show_views'] = "0";
			$args['show_likes'] = "0";
			$args['show_comment_count'] = "0";
			$args['image_size'] = "gum_70X90";
			$args['flip'] = "0";
			$args['special'] = "1";

			return self::block_3($args);
		} 
		else{
		return self::block_3($args1);
		}
	}
	public static function block_5($grid_args){
		$block_defaults = array (
 			'class' => 'col-sm-6',
 			'show_cat' => 1,
			'show_date' => 0,
			'show_author' => 0,
			'show_views' => 0,
			'show_likes' => 0,
			'show_comment_count' => 0,
			'show_excerpt' => 1,
			'date_type' => 'date_ago',
			'title_word_count' => 10,
			'show_title' => '1',
			'excerpt_word_count' => 24,
			'image_size' => 'gum_250X320',
			'row_class' => '',
			'read_more' => 0,
			'posts_view_count' => array(),
			'show_reviews' => 0,
 		);
		// Parse $grid_args into an array and merge it with $defaults
		$args = self::get_args($grid_args, $block_defaults);

		extract($args);

		$post_id = get_the_ID();

		$html = '';
		
		if(!empty($post_id)){
			
			$img_src = self::get_featured_image($post_id, $image_size);
			$post_permalink = get_the_permalink();

			$number_words = $title_word_count;
			$post_title = wp_trim_words(get_the_title(), $number_words, self::$more_text);

			$post_excerpt = wp_trim_words(get_the_excerpt(), $excerpt_word_count, self::$more_text);

			$post_date = self::get_date($show_date, $date_type);
			$review_html = self::get_post_review($post_id);
			$cat_html = '';
			if($show_cat == 1) $cat_html = gum_html::block_cat_html($post_id,' ',1);

			$likes_html = self::get_post_likes_count($post_id, $show_likes);
			$views_html = self::get_post_view_count($post_id, $show_views, false, $posts_view_count);
			$comment_count_html = self::get_post_comment_count($post_id, $show_comment_count);

			$cat_class = self::get_cat_class();

	$html = "<div class='gum-block-wrapper gum-block-5-wrapper $class $cat_class'>
		<div class='gum-block gum-block-5'>
			<div class='row'>
		<div class='col-md-4'>";

		$html .= "<div class='block4-image-holder'><a href='$post_permalink' class='gum-block-post-img'>
				<img src='$img_src' alt= '$post_title' class='gum-p-img'/>";
			if(!empty($format) && $format =='video') $html .= "<span class='post-play-btn'><i class='fa fa-play' aria-hidden='true'></i></span>";
			$html .= "</a>";
		
		$html.="<div class='tag gum-post-cat'>";
		if($show_cat) $html .=$cat_html;
		if($show_reviews) $html .=$review_html;
		$html .="</div>";

			$html .= "</div><!-- .block4-image-holder -->
			</div><!-- col-md-4 -->";
		
		 
			
	$html .="<div class='gum-block-data col-md-8'><div class='content'>";	

	if(strlen($likes_html) > 0 || strlen($views_html) > 0 || strlen($comment_count_html) > 0 || strlen($post_date) > 0 || $show_author == 1) 
		$html .= "<ul>";

	$html .= $likes_html;
	$html .= $views_html;
	$html .= $comment_count_html;
	if($show_author == 1){
		$auth_class = '';
		if(strlen($post_date) > 0) $auth_class = "divider";
		$html .= "<li class='block-post-author'><i class='fa fa-user'></i>".get_the_author()."</li>";
	}

	if(strlen($post_date) > 0) $html .= "<li class='block-date'><i class='fa fa-calendar'></i>$post_date</li>";

	if(strlen($likes_html) > 0 || strlen($views_html) > 0 || strlen($comment_count_html) > 0 || strlen($post_date) > 0 || $show_author == 1) $html .= "</ul>";
	
	$html .="<h2 class='gum-block-post-title'><a href='$post_permalink' >$post_title</a></h2>";

	if($show_excerpt ==1) $html .= "<p class='excerpt'>$post_excerpt</p>";
			
	$html .= '</div></div><!-- col-md-8 -->';
			
	$html .= "</div></div><!-- .gum_post_data --></div>";



		}
		return $html;
	}
	public static function block_6($grid_args){
 			$block_defaults = array (
 			'class' => '',
 			'show_cat' => 1,
			'show_mask' => 1,
			'show_date' => 1,
			'show_author' => 1,
			'show_views' => 1,
			'show_likes' => 1,
			'show_comment_count' => 1,
			'show_excerpt' => 1,
			'date_type' => 'date_ago',
			'show_title' => '1',
			'title_word_count' => 10,
			'excerpt_word_count' => 30,
			'image_size' => 'gum_400X240',
			'row_class' => '',
			'read_more' => 0,
			'posts_view_count' => array(),
			'slider_show_cat' => 0,
			'font_size_class' => ' ',
			'show_reviews' => 0,
 		);
 		global $gumtheme_options;
 		
		// Parse $grid_args into an array and merge it with $defaults
		$args = self::get_args($grid_args, $block_defaults);
		extract($args);


		$post_id = get_the_ID();
		$format = get_post_format( $post_id );
		$html = '';
		if(!empty($post_id)){

			$img_src = self::get_featured_image($post_id, $image_size);
			
			$post_permalink = get_the_permalink();

			$number_words = $title_word_count;
			$post_title = wp_trim_words(get_the_title(), $number_words, self::$more_text);

			$post_excerpt = wp_trim_words(get_the_excerpt(), $excerpt_word_count, self::$more_text);

			$post_date = self::get_date($show_date, $date_type);
			$review_html = self::get_post_review($post_id);
			$cat_html = '';
			$cat_html = gum_html::block_cat_html($post_id,' ',1);

			$likes_html = self::get_post_likes_count($post_id, $show_likes);
			$mask_likes_html=self::get_post_Mask_likes_count($post_id, $show_likes);
			$views_html = self::get_post_view_count($post_id, $show_views, false, $posts_view_count);
			$comment_count_html = self::get_post_comment_count($post_id, $show_comment_count);

			$cat_class = self::get_cat_class();

		$html = "<div class='$class block-6-posts'>";

		$html .="<div class='small-posts'>                  
                      <div class='post'>
                        <div class='img-holder'>";   

        $html.="<div class='tag'>";
		if($show_cat) $html .=$cat_html;
		if($show_reviews) $html .=$review_html;
		$html .="</div>";

		$html .="<a href='$post_permalink'>
					<img src='$img_src' class='img-fluid' alt='$post_title'>
				  </a>
				</div>";

		if(strlen($likes_html) > 0 || strlen($views_html) > 0 || strlen($comment_count_html) > 0 || $show_author == 1 || $show_date == 1)
	        $html.="<ul>";

	        if($show_likes) $html .="$likes_html";
	        if($show_views) $html.="$views_html";
	        if($show_comment_count) $html.="$comment_count_html";

	        if($show_author == 1){
				$auth_class = '';
				if(strlen($post_date) > 0) $auth_class = "divider";
				$html .= "<li class='block-post-author $auth_class'><i class='fa fa-user'></i>".get_the_author()."</li>";
			}
	        if($show_date) $html.="<li class='gum-block-date'><i class='fa fa-calendar'></i> $post_date</li>";
	        if(strlen($likes_html) > 0 || strlen($views_html) > 0 || strlen($comment_count_html) > 0 || $show_author == 1 || $show_date == 1)
	        $html.="</ul>";
    	

        if($show_title)
            $html .="<h2 class='$font_size_class'><a href='$post_permalink'>$post_title</a></h2>";		

        if($show_excerpt) $html.="<p class='excerpt'>$post_excerpt</p>";
        if($read_more) $html .= "<a href='$post_permalink' class='gum-read-more'>".__('Read More', 'bloom-gumtheme')."</a>";
				            
				            $html .="
				          </div>				        
				    </div>";

		$html .="</div>";		

		}
		unset($args);
		return $html;
 		}

 	public static function block_7($grid_args){
		$block_defaults = array (
 			'class' => '',
 			'show_cat' => 1,
			'show_mask' => 1,
			'show_date' => 1,
			'show_author' => 0,
			'show_views' => 1,
			'show_likes' => 1,
			'show_comment_count' => 1,
			'show_excerpt' => 1,
			'date_type' => 'date_ago',
			'show_title' => '1',
			'title_word_count' => 8,
			'excerpt_word_count' => 20,
			'image_size' => 'gum_400X240',
			'row_class' => '',
			'read_more' => 0,
			'posts_view_count' => array(),
			'slider_show_cat' => 0,
			'font_size_class' => ' ',
			'show_reviews' => 0,
 		);
 		global $gumtheme_options;
 		
		// Parse $grid_args into an array and merge it with $defaults
		$args = self::get_args($grid_args, $block_defaults);

		extract($args);

		$post_id = get_the_ID();
		$format = get_post_format( $post_id );
		$html = '';
		if(!empty($post_id)){

			$img_src = self::get_featured_image($post_id, $image_size);
			
			$post_permalink = get_the_permalink();

			$number_words = $title_word_count;
			$post_title = wp_trim_words(get_the_title(), $number_words, self::$more_text);

			$post_excerpt = wp_trim_words(get_the_excerpt(), $excerpt_word_count, self::$more_text);

			$post_date = self::get_date($show_date, $date_type);
			$review_html = self::get_post_review($post_id);
			$cat_html = '';
			if($show_cat == 1) $cat_html = gum_html::block_cat_html($post_id,' ',1);

			$likes_html = self::get_post_likes_count($post_id, $show_likes,false,' ');
			$mask_likes_html=self::get_post_Mask_likes_count($post_id, $show_likes);
			$views_html = self::get_post_view_count($post_id, $show_views, false, $posts_view_count,' ');
			$comment_count_html = self::get_post_comment_count($post_id, $show_comment_count,false,' ');

			$cat_class = self::get_cat_class();

		$html = "<div class='$class block-7-posts'>";

		$html .="<div class='small-posts'>                  
                      <div class='post'>
                        <div class='img-holder'>";   

		$html.="<div class='tag'>";
		if($show_cat) $html .=$cat_html;
		if($show_reviews) $html .=$review_html;
		$html .="</div>";

		$html .="<a href='$post_permalink'>
					<img src='$img_src' class='img-fluid' alt='$post_title'>
				  </a>
				</div>";

		if(strlen($likes_html) > 0 || strlen($views_html) > 0 || strlen($comment_count_html) > 0)
	        $html.="<ul>";

        if($show_likes) $html .="$likes_html";
        if($show_views) $html.="$views_html";
        if($show_comment_count) $html.="$comment_count_html";
        if($show_date) $html.="<li class='gum-block-date'><i class='fa fa-calendar'></i> $post_date</li>";
        if(strlen($likes_html) > 0 || strlen($views_html) > 0 || strlen($comment_count_html) > 0)
        $html.="</ul>";
    	

    	if($show_author == 1 || $show_date == 1)
    		$html.="<ul class='author-list'>";
        if($show_author == 1){
			$auth_class = '';
			if(strlen($post_date) > 0) $auth_class = "divider";
			$html .= "<li class='block-post-author $auth_class'><i class='fa fa-user'></i>".get_the_author()."</li>";
		}
        

        if($show_author == 1 || $show_date == 1)
    		$html.="</ul>";

        if($show_title)
            $html .="<h2 class='$font_size_class'><a href='$post_permalink'>$post_title</a></h2>";	

        if($show_excerpt) $html.="<p class='excerpt'>$post_excerpt</p>";
        if($read_more) $html .= "<a href='$post_permalink' class='gum-read-more'>".__('Read More', 'bloom-gumtheme')."</a>";
				            
				            $html .="
				          </div>				        
				    </div>";

		$html .="</div>";		

		}
		unset($args);
		return $html;
	}

	public static function block_8($grid_args){
		$block_defaults = array (
 			'class' => 'description-posts',
			'image_size' => 'gum_150X90',
			'show_cat' => 1,
			'show_date' => 1,
			'show_author' => 0,
			'show_views' => 0,
			'show_likes' => 0,
			'show_comment_count' => 0,
			'show_excerpt' => 0,
			'date_type' => 'date_ago',
			'title_word_count' => 7,
			'excerpt_word_count' => 20,
			'row_class' => 'post',
			'read_more' => 0,
			'posts_view_count' => array(),
			'block_data_class' => ' ',
			'show_reviews' => 0,
 		);
		
		// Parse $grid_args into an array and merge it with $defaults
		$args = self::get_args($grid_args, $block_defaults);

		extract($args);

		if(isset($grid_args['post_sort_by']) && $grid_args['post_sort_by'] == 'high_review'){
			$show_reviews=1;
		}

		$post_id = get_the_ID();
		$format = get_post_format( $post_id );
		$html = '';
		if(!empty($post_id)){
			$img_src = self::get_featured_image($post_id, $image_size);
			$post_permalink = get_the_permalink();
			$number_words = $title_word_count;
			$post_title = wp_trim_words(get_the_title(), $number_words, self::$more_text);

			$post_date = self::get_date($show_date, $date_type);
			$review_html = self::get_post_review($post_id);
			$cat_html = '';
			if($show_cat == 1) $cat_html = gum_html::block_cat_html($post_id,'gum-post-cat',1);
			if($show_excerpt ==1) $post_excerpt = wp_trim_words(get_the_excerpt(), $excerpt_word_count, self::$more_text);
			
			$likes_html = self::get_post_likes_count($post_id, $show_likes,false,' ');
			$views_html = self::get_post_view_count($post_id, $show_views, false, $posts_view_count,' ');
			$comment_count_html = self::get_post_comment_count($post_id, $show_comment_count,false,' ');
			
			$cat_class = self::get_cat_class();


			$html = "<div class='gum-block-2-wrapper $class $cat_class'>
						<div class='gum-block gum-block-2 $row_class'>								
									
			<a href='$post_permalink' class='gum-block-post-img'>
				<img src='$img_src' alt= '$post_title' class='gum-p-img'/>";

			if(!empty($format) && $format =='video') $html .= "<span class='post-play-btn'><i class='fa fa-play' aria-hidden='true'></i></span>";
			$html .= "</a>
								
							
			<div class='gum-block-data $block_data_class'>

				<h2 class='gum-block-post-title'><a href='$post_permalink'>$post_title</a></h2>";
				

				if($show_reviews || strlen($post_date) > 0) $html .= "<ul class='small-block-lists grid-2-small-ttab1 tag1'>";
				
				if(strlen($post_date) > 0) $html .= "<li class='block-date'><i class='fa fa-calendar'></i>$post_date</li>";
				if($show_reviews) $html .='<li>'.$review_html.'</li>';

				if($show_reviews || strlen($post_date) > 0)$html .= "</ul>";

				if(strlen($likes_html) > 0 || strlen($views_html) > 0 || strlen($comment_count_html) > 0 || $show_author == 1) $html .= "<ul class='small-block-lists grid-2-small-ttab2'>";
				$html .= $likes_html;
				$html .= $views_html;
				$html .= $comment_count_html;


				if($show_author == 1){
					$auth_class = '';
					if(strlen($post_date) > 0) $auth_class = "divider";
					$html .= "<li class='block-post-author $auth_class'><i class='fa fa-user'></i>".get_the_author()."</li>";
				}

				if(strlen($likes_html) > 0 || strlen($views_html) > 0 || strlen($comment_count_html) > 0 || $show_author == 1) $html .= "</ul>";
				$html .= "<div class='clearfix'></div>";
				
				if($show_excerpt ==1) $html .= "<p>$post_excerpt</p>";
				if($read_more == 1) $html .= "<a href='$post_permalink' class='gum-read-more'>".__('Read More', 'bloom-gumtheme')."</a>";

			$html .= "</div><!-- .gum_post_data --><div class='clearfix'></div>
		</div><!-- gum-block -->
	</div>";
		}
		return $html;

	}
	public static function get_cat_slug($cat_id) {
		$cat_id = (int) $cat_id;
		$category = get_category($cat_id);
		return $category->slug;
	}
	public static function posts_block_header_with_nav($options){

		$id = $options['id'];
		$html = '';
		if(!empty($options['gum_grid_title']) || ( !empty($options['gum_ajax_filter_type']) && $options['gum_ajax_filter_type'] != 'none')): 
			$html .= '<div class="gum-grid-block-title">  <div class="inner-title"><div class="span"></div>';
				if(!empty($options['gum_grid_title'])): 
					$html .= '<h1>';
					if(!empty($options['gum_grid_title_link'])) $html .= "<a href='".$options['gum_grid_title_link']."'>";
					$html .=  $options['gum_grid_title'];
					if(!empty($options['gum_grid_title_link'])) $html .=  "</a>";
					$html .= '</h1></div><!--title closed-->';
				endif;

				if(!empty($options['gum_ajax_filter_type']) && $options['gum_ajax_filter_type'] != 'none' && $options['gum_ajax_filter_type'] != 'no'):
				
					$cats = explode(",", $options['ajax_cat_filter']);
					
					if(!empty($cats)):
						if($options['gum_ajax_filter_type'] == 'dropdown'): 
$html .= '<div class="gum_cat_filter_dropdown btn-group right-aligned">';
$html .= '<button type="button" class="gum_cat_filter_dropdown_selected btn btn-default dropdown-toggle btn-xs" data-filter_id="0" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">'.$options['ajax_cat_filter_default_text'].'</button>';
$html .= '<ul class="gum_cat_filter dropdown-menu dropdown-menu-right" data-div_id="'.$id.'" data-filter_type="dropdown">';
$html .= '<li><a href="#" data-filter_id="0" class="gum_cat_filter_a active">'.$options['ajax_cat_filter_default_text'].'</a></li>';
							foreach($cats as $cat_name){

								if(is_int($cat_name)){

								$cat_id=get_cat_ID($cat_name);
								$cat_slug=self::get_cat_slug($cat_id);
								//'.get_site_url().'/category/'.$cat_slug.'
								$html .= '<li><a href="#" data-filter_id="'.$cat_name.'" class="gum_cat_filter_a">'.$cat_name.'</a></li>';

								}
								else{
									$html .= '<li><a href="#" data-filter_id="'.$cat_name.'" class="gum_cat_filter_a">'.get_cat_name($cat_name).'</a></li>';
								}
							}
							$html .= '</ul>';
							$html .= '</div>';

							
						elseif ($options['gum_ajax_filter_type'] == 'list'): 
$html .= '<div class="gum_cat_filter_list right-aligned">';
//$html .= '<div class="gum_cat_filter_dropdown_selected" data-filter_id="0" style="display:none">'.$options['ajax_cat_filter_default_text'].'</div>';
$html .= '<ul class="gum_cat_filter list-style-filter" data-div_id="'.$id.'" data-filter_type="list">';
$html .= '<li><a href="#" data-filter_id="0" class="gum_cat_filter_a active">'.$options['ajax_cat_filter_default_text'].'</a></li>';
							foreach($cats as $cat_name){
								if(is_int($cat_name)){
								$cat_id=get_cat_ID($cat_name);
								$cat_slug=self::get_cat_slug($cat_id);

								$html .= '<li><a href="'.get_site_url().'/category/'.$cat_slug.'" class="">'.$cat_name.'</a></li>';
								}
								else{
									$html .= '<li><a href="#" data-filter_id="'.$cat_name.'" class="gum_cat_filter_a">'.get_cat_name($cat_name).'</a></li>';
								}
							} 
							$html .= '</ul>';
							$html .= '</div>';

						endif; //gum_ajax_filter_type 

					endif; //!empty($cats)
				endif; //!empty($options['gum_ajax_filter_type']
				$html .= '<div class="clearfix"></div>';
				$html .= '</div><!-- gum-grid-block-title -->';
		endif; //!empty($options['gum_grid_title']) || ( !empty($options['gum_ajax_filter_type']) 
		
		return $html;
	}
	

	public static function posts_block_footer($options){
		global $gumtheme_translations;
        $id = $options['id'];
        $html = '';
	    if(!empty($options['gum_grid_pagination']) && $options['gum_grid_pagination'] != 'none'){ 
				if($options['gum_grid_pagination'] == 'next_prev'){ 
                    $html .= '<ul class="gum_block_pagination pagination pagination-sm" data-div_id="'.$id.'" data-type="prev_next">
						<li class="gb_pagination_a gb_pagination_a_prev disable" data-direction="prev"><a href="#"><i class="fa fa-angle-left" aria-hidden="true"></i></a></li>
						<li class="gb_pagination_a gb_pagination_a_next" data-direction="next"><a href="#"><i class="fa fa-angle-right" aria-hidden="true"></i></a></li>
					</ul>
					<div class="clearfix"></div>';
                }
			
				if($options['gum_grid_pagination'] == 'load_more'){ 
						if(!empty($gumtheme_translations['load_more_text'])) $load_more_text = $gumtheme_translations['load_more_text'];
						else $load_more_text = 'Load more';
				
                        $html .= '<div class="loading_msg"></div>
                        <ul class="gum_block_pagination gum_block_pagi_loadmore" data-div_id="'.$id.'" data-type="loadmore">
                            <li class="gb_pagination_a gb_pagination_a_next" data-direction="next"><a href="#">'.$load_more_text.'</a></li>
                        </ul>
                        <div class="clearfix"></div>';
				}
        }
        return $html;

	}

	/**
	 * HTML output for menu
	 * @param  array $args options for blocks
	 * @return string       html output of the menu block
	 */
	public static function menu_block($args){
		global $mage_menu_settings;
		$post_id = get_the_ID();
		if(isset($args['image_size'])) $imgae_size = $args['image_size'];
		else if(isset($mage_menu_settings['image_size']['default'])) $imgae_size = $mage_menu_settings['image_size']['default'];
		else $imgae_size = 'gum_300X180';
		$return_data = array();
		$html = '';
		if(!empty($post_id)){
			$img_src= '';
			if ( has_post_thumbnail($post_id ) ) {
				$post_image = wp_get_attachment_image_src( get_post_thumbnail_id( $post_id ), $imgae_size );
				$img_src = $post_image[0];
			}
			$post_permalink = get_the_permalink();

			$number_words = 7;
			$post_title = wp_trim_words(get_the_title(), $number_words, self::$more_text);
			$review_html = self::get_post_review($post_id);
			$cat_html = gum_html::block_cat_html($post_id,'gum-post-cat',1);
			$format = get_post_format( $post_id );
			if(!empty($review_html)) $return_data['has_review'] = true;

			$cat_class = self::get_cat_class();

			$html = "<div class='gum-block-wrapper gum-menu-block-wrapper col-sm-4 $cat_class'>
				<div class='gum-block gum-menu-block'>";
            
			$html .= "<div class='img-holder'>	 $cat_html
					<a href='$post_permalink' class='gum-block-post-img'>

						<img src='$img_src' alt= '$post_title' />";

						if(!empty($format) && $format =='video') $html .= "<span class='post-play-btn'><i class='fa fa-play' aria-hidden='true'></i></span>";
			$html .= "</a></div>";
            
			$html .= "<div class='gum-block-data'>
					<h3 class='gum-block-post-title'><a href='$post_permalink'>$post_title</a></h3>";
					if(!empty($review_html)) $html .=  $review_html;
					
					$html .= "</div><!-- .gum_post_data -->
				</div><!-- gum-block -->
			</div><!-- gum-menu-block-wrapper -->";



		}
		$return_data['html'] = $html;
		return $return_data;
	}

	public static function get_topbar_social_sites($hover_effect_class=''){
		global $gumtheme_options;

		$social_sites = array(
			"behance" => array("title" => "Behance" , "fa_class" => "fa-behance", "callback"=>""),
			"blogger" => array("title" => "Blogger" , "fa_class" => "", "callback"=>""),
			"delicious" => array("title" => "Delicious" , "fa_class" => "fa-delicious", "callback"=>""),
			"deviantart" => array("title" => "Deviantart" , "fa_class" => "fa-deviantart", "callback"=>""),
			"digg" => array("title" => "Digg" , "fa_class" => "fa-digg", "callback"=>""),
			"dribbble" => array("title" => "Dribbble" , "fa_class" => "fa-dribbble", "callback"=>""),
			"evernote" => array("title" => "Evernote" , "fa_class" => "", "callback"=>""),
			"facebook" => array("title" => "Facebook" , "fa_class" => "fa-facebook", "callback"=>""),
			"flickr" => array("title" => "Flickr" , "fa_class" => "fa-flickr", "callback"=>""),
			"forrst" => array("title" => "Forrst" , "fa_class" => "", "callback"=>""),
			"googleplus" => array("title" => "GooglePlus" , "fa_class" => "fa-google-plus", "callback"=>""),
			"grooveshark" => array("title" => "Grooveshark" , "fa_class" => "", "callback"=>""),
			"html5" => array("title" => "Html5" , "fa_class" => "fa-html5", "callback"=>""),
			"instagram" => array("title" => "Instagram" , "fa_class" => "fa-instagram", "callback"=>""),
			"lastfm" => array("title" => "Lastfm" , "fa_class" => "fa-lastfm", "callback"=>""),
			"linkedin" => array("title" => "Linkedin" , "fa_class" => "fa-linkedin", "callback"=>""),
			"mail" => array("title" => "Mail" , "fa_class" => "fa-envelope-o", "callback"=>"social_mail"),
			"path" => array("title" => "Path" , "fa_class" => "", "callback"=>""),
			"paypal" => array("title" => "Paypal" , "fa_class" => "fa-paypal", "callback"=>""),
			"picasa" => array("title" => "Picasa" , "fa_class" => "", "callback"=>""),
			"pinterest" => array("title" => "Pinterest" , "fa_class" => "fa-pinterest-p", "callback"=>""),
			"posterous" => array("title" => "Posterous" , "fa_class" => "", "callback"=>""),
			"reddit" => array("title" => "Reddit" , "fa_class" => "fa-reddit-alien", "callback"=>""),
			"rss" => array("title" => "Rss" , "fa_class" => "fa-rss", "callback"=>""),
			"share"  => array("title" => "Share" , "fa_class" => "fa-share", "callback"=>""),
			"skype" => array("title" => "Skype" , "fa_class" => "fa-skype", "callback"=>""),
			"soundcloud" => array("title" => "Soundcloud" , "fa_class" => "fa-soundcloud", "callback"=>""),
			"spotify" => array("title" => "Spotify" , "fa_class" => "fa-spotify", "callback"=>""),
			"stackoverflow" => array("title" => "Stackoverflow" , "fa_class" => "fa-stack-overflow", "callback"=>""),
			"steam" => array("title" => "Steam" , "fa_class" => "fa-steam", "callback"=>""),
			"stumbleupon" => array("title" => "StumbleUpon" , "fa_class" => "fa-stumbleupon", "callback"=>""),
			"tumblr" => array("title" => "Tumblr" , "fa_class" => "fa-tumblr", "callback"=>""),
			"twitter" => array("title" => "Twitter" , "fa_class" => "fa-twitter", "callback"=>""),
			"vimeo" => array("title" => "Vimeo" , "fa_class" => "fa-vimeo", "callback"=>""),
			"vkontakte" => array("title" => "VKontakte" , "fa_class" => "fa-vk", "callback"=>""),
			"windows" => array("title" => "Windows" , "fa_class" => "fa-windows", "callback"=>""),
			"wordpress" => array("title" => "Woordpress" , "fa_class" => "fa-wordpress", "callback"=>""),
			"yahoo" => array("title" => "Yahoo" , "fa_class" => "fa-yahoo", "callback"=>""),
			"youtube" => array("title" => "Youtube" , "fa_class" => "fa-youtube", "callback"=>""),
		);
		$html = '';

		foreach($social_sites as $key => $site){

			if(!empty($gumtheme_options[$key])){

				$url = $gumtheme_options[$key];
				if(!empty($site['callback'])){

					$method =  $site['callback'];
					$html .= self::$method($site, $url);
				}
				else $html .= ' <li class="topbar-'.$key.'"><a class="'.$hover_effect_class.'" href="'.$url.'"><i class="fa '.$site['fa_class'].'" aria-hidden="true"></i></a></li>';
			}
		}

		return $html;
	}

	public static function social_mail($site, $value){

		$html = ' <li><a href="mailto:'.$value.'"><i class="fa '.$site['fa_class'].'" aria-hidden="true"></i></a></li>';

		return $html;
	}

}
