<?php
	/* Theme Menu html **/

	class Gum_menu_html{

		public $menu_type;
		public $gum_menu_id;
		public $cat_id;
		public $exta_cat_ids; // for sidebar - style 2
		public $menu_style;
		public $page_id;
		public $post_limit = 3;
		public $return_data;

		static $item_class = 'col-md-3 col-sm-6 gum_mega_menu_post_item_wrapper';

		public function __construct($values){

			if(isset($values['menu_type'])) $this->menu_type = $values['menu_type'];
			if(isset($values['cat_id'])) $this->cat_id = $values['cat_id'];
			if(isset($values['menu_style'])) $this->menu_style = $values['menu_style'];
			if(isset($values['page_id'])) $this->page_id = $values['page_id'];
			if(isset($values['exta_cat_ids'])) $this->exta_cat_ids = $values['exta_cat_ids'];

			if(isset($values['gum_menu_id'])) $this->gum_menu_id = $values['gum_menu_id'];
			$this->return_data = array("html"=>"", "post_count"=>"", "has_posts"=>false, "post_limit"=>$this->post_limit);
			$this->ProcessMenu();

		}

		private function ProcessMenu(){

			if($this->menu_type == 'cat') $this->MenuCat();
			if($this->menu_type == 'page') $this->MenuPage();

		}

		private function MenuPage(){
			$this->return_data['has_posts'] = true;
			if($this->page_id > 0){


				$post = get_post($this->page_id);
				$this->return_data['html'] .= '<div class="col-sm-12 nav_page_content">';
				$this->return_data['html'] .= do_shortcode( $post->post_content );
				$this->return_data['html'] .= '</div>';
			}
			else $this->return_data['html'] .= '<div class="col-sm-12 nav_page_content">Page not set</div>';

		}

		private function MenuCat(){
			
			$post_args = array();
		if($this->menu_style =='style_1'):

			$args = array('posts_per_page'=> $this->post_limit);
			if($this->cat_id > 0) $args['category_id'] = $this->cat_id;

			$posts_helper = GumHelper::getposts($args);
			$the_query = $posts_helper['the_query'];
			//var_dump($posts);
			$id = $this->gum_menu_id."_".$this->cat_id;

			$this->return_data['html'] .= '<div class="nav_post_items gum-style-1" id="">';
			$this->return_data['html'] .= gum_html::spinner();
			if(!empty($the_query)){
				if($the_query->have_posts()){
					$this->return_data['has_posts'] = true;
					$this->return_data['post_count'] = $the_query->post_count;


					$count = 0;

					$post_args['image_size'] = 'gum_350X210';

					$review_class = '';

					$block_html = '';
					while ( $the_query->have_posts() ) { $the_query->the_post();

						$block = gum_html::menu_block($post_args);
						if(!empty($block['has_review'])) $review_class = 'gum-posts-has-review';

						$block_html .= $block['html'];

						if($count == 2) $block_html .= '<div class="clearfix"></div>';

						$count++;

						wp_reset_postdata();
					}
					$this->return_data['html'] .= '<div class="gum_mega_cat_posts_wrapper">';
					$this->return_data['html'] .= '<div id="'.$id.'" class="gum_mega_cat_posts row '.$review_class.'">';

					$this->return_data['html'] .= $block_html;
					$this->return_data['html'] .= '</div><!-- gum_mega_cat_posts -->';
					$this->return_data['html'] .= '</div><!-- gum_mega_cat_posts_wrapper -->';
				}
			}

			$this->return_data['html'] .= '<div class="gum-menu-pagi-wrapper">
				<ul class="gum_megamenu_pagination pagination pagination-sm" data-div_id="'.$this->gum_menu_id.'" data-cat_id="'.$this->cat_id.'" data-menu_style="style_1" data-limit="'.$this->post_limit.'">
					<li class="gum-megamenu-pagination-a gum-megamenu-pagination-a-prev" data-direction="prev"><a href="#"><i class="fa fa-angle-left" aria-hidden="true"></i></a></li>
					<li class="gum-megamenu-pagination-a gum-megamenu-pagination-a-next" data-direction="next"><a href="#"><i class="fa fa-angle-right" aria-hidden="true"></i></a></li>
				</ul>
			</div>
			<div class="clearfix"></div>
		</div> <!-- nav_post_items -->';


		elseif($this->menu_style =='style_2'):


			if(!empty($this->exta_cat_ids)) $this->exta_cat_ids = explode(",", $this->exta_cat_ids);

			$args = array('posts_per_page'=> $this->post_limit);
			if($this->cat_id > 0) $args['category_id'] = $this->cat_id;

			$posts_helper = GumHelper::getposts($args);
			$the_query = $posts_helper['the_query'];
			$id = $this->gum_menu_id."_".$this->cat_id;
			//$id = $this->gum_menu_id;

			$this->return_data['html'] .= '<div class="row">
            <div class="col-sm-3 col-md-2 col-xs-3 gum_mega_cat_list-ab gum-style-2"></div>
			<div class="col-sm-3 col-md-2 col-xs-3 gum_mega_cat_list gum-style-2">

			<ul class="gum_mega_sub_cat">
				<li><a href="'.$this->cat_id.'" data-post_div="'.$id.'" data-get_posts="0" data-megamenu-cat="'.$this->cat_id.'" class="gum_mega_post_cats gum_mega_active">All</a></li>';

				$cat_div_html = '';
				if(!empty($this->exta_cat_ids)){
		  			foreach($this->exta_cat_ids as $sidebar_cat_id){
			  			$sidebar_cat =  get_term( $sidebar_cat_id);
		      			$cat_div_id = $this->gum_menu_id."_".$sidebar_cat_id;
		      			$this->return_data['html'] .= '<li><a href="'.get_category_link( $sidebar_cat_id ).'" data-post_div="'.$cat_div_id.'" data-get_posts="1"  data-megamenu-cat="'.$sidebar_cat_id.'"  class="gum_mega_post_cats">'.$sidebar_cat->name.'</a></li>';
		      			$cat_div_html .= '<div id="'.$cat_div_id.'"  class="gum_mega_cat_posts row" style="display:none"></div>';
		  			}

				}

			$this->return_data['html'] .= '</ul>
			</div>
			<div class="col-sm-9 col-md-10 col-xs-9 nav_post_items gum_mega_cat_show">';
			$this->return_data['html'] .= gum_html::spinner();
				if(!empty($the_query)){
					if($the_query->have_posts()){
						$this->return_data['has_posts'] = true;
						$this->return_data['post_count'] = $the_query->post_count;

												$count = 0;
						$review_class = '';

						$block_html = '';

						while ( $the_query->have_posts() ) { $the_query->the_post();

							$block = gum_html::menu_block($post_args);
							if(!empty($block['has_review'])) $review_class = 'gum-posts-has-review';

							$block_html .= $block['html'];


							$count++;
							wp_reset_postdata();
						}
						$this->return_data['html'] .= '<div id="'.$id.'" class="gum_mega_cat_posts row '.$review_class.'">';
						$this->return_data['html'] .= $block_html;

						$this->return_data['html'] .= '<div class="clearfix"></div>';
						$this->return_data['html'] .= '</div><!-- gum_mega_cat_posts -->';
					}
				}
				$this->return_data['html'] .= $cat_div_html;
				$this->return_data['html'] .= '<div class="gum-menu-pagi-wrapper">
				<ul class="gum_megamenu_pagination pagination pagination-sm" data-div_id="'.$this->gum_menu_id.'" data-cat_id="'.$this->cat_id.'" data-menu_style="style_2" data-limit="'.$this->post_limit.'">
					<li class="gum-megamenu-pagination-a gum-megamenu-pagination-a-prev" data-direction="prev"><a href="#"><i class="fa fa-angle-left" aria-hidden="true"></i></a></li>
					<li class="gum-megamenu-pagination-a gum-megamenu-pagination-a-next" data-direction="next"><a href="#"><i class="fa fa-angle-right" aria-hidden="true"></i></a></li>
				</ul>
			</div>
			</div>
            </div><!-- .row -->';



		endif;



	}

}