<?php
/**
 * The template for displaying all pages.
 *
 * This is the template that displays all pages by default.
 * Please note that this is the WordPress construct of pages
 * and that other 'pages' on your WordPress site will use a
 * different template.
 *
 * @package bloom
 */

get_header(); 

    $mainclass='';
    $post_id = get_the_ID();
    $page_layout = get_post_meta($post_id, 'gum_page_width_class', true);

    if($page_layout == 'boxed')
        $mainclass='container';

?>

<div class="<?php echo $mainclass; ?>">
<?php
    $gum_sidebar_position = Gum_html::get_single_post_sidebar_position();
    $article_div_wrapper_class = "col-sm-9 col-md-8";
    $article_div_row_class = "row";
    // if full page then don't add col-* and row classes
    if(!empty($gum_sidebar_position) && $gum_sidebar_position == 'none'){
        $article_div_wrapper_class = "";
        $article_div_row_class = "";
    }
    if(!empty($gum_sidebar_position) && $gum_sidebar_position == 'left') $article_div_row_class .= " content_left_sidebar";
    else if(!empty($gum_sidebar_position) && ( $gum_sidebar_position == 'right' ||  $gum_sidebar_position == 'default')) $article_div_row_class .= " content_right_sidebar";
    else $article_div_row_class .= " content_none_sidebar";
?>
<div class="<?php echo $article_div_row_class; ?> gum-row sector">
<?php if(!empty($gum_sidebar_position) && $gum_sidebar_position == 'left') get_sidebar(); ?>
<div id="primary" class="content-area gum-single-post blog <?php echo $article_div_wrapper_class;?>">

		<main id="main" class="site-main">

			<?php while ( have_posts() ) : the_post(); ?>

				<?php get_template_part( 'template-parts/content', 'page' ); ?>

			<?php endwhile; // End of the loop. ?>

		</main><!-- #main -->
</div><!-- #primary -->

	<?php if(!empty($gum_sidebar_position) && ( $gum_sidebar_position == 'right' )) get_sidebar(); ?>
</div><!-- row -->
</div><!-- .container -->
<?php get_footer(); ?>
